System.register(["tslib", "@web-atoms/web-controls/dist/mobile-app/MobileApp", "@web-atoms/web-controls/dist/desktop-app/DesktopApp", "@web-atoms/core/dist/web/services/PopupService", "./menu/AppMenu", "@web-atoms/core/dist/Pack", "./styles/GlobalStyle", "./common/ThisApp", "@web-atoms/core/dist/core/XNode", "./commands/AppCommands", "@web-atoms/core/dist/core/Command"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, MobileApp, DesktopApp, PopupService, AppMenu, Pack, ThisApp, XNode, AppCommands, Command, AppClass, AppIndex;
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
    }, function (_webAtomsWebControlsDistMobileAppMobileApp) {
      MobileApp = _webAtomsWebControlsDistMobileAppMobileApp.default;
    }, function (_webAtomsWebControlsDistDesktopAppDesktopApp) {
      DesktopApp = _webAtomsWebControlsDistDesktopAppDesktopApp.default;
    }, function (_webAtomsCoreDistWebServicesPopupService) {
      PopupService = _webAtomsCoreDistWebServicesPopupService.default;
    }, function (_menuAppMenu) {
      AppMenu = _menuAppMenu.default;
    }, function (_webAtomsCoreDistPack) {
      Pack = _webAtomsCoreDistPack.default;
    }, function (_stylesGlobalStyle) {}, function (_commonThisApp) {
      ThisApp = _commonThisApp.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_commandsAppCommands) {
      AppCommands = _commandsAppCommands.default;
    }, function (_webAtomsCoreDistCoreCommand) {
      Command = _webAtomsCoreDistCoreCommand.default;
    }],
    execute: function () {
      AppClass = /android|iPhone/i.test(navigator.userAgent) ? MobileApp : DesktopApp;
      AppIndex = class AppIndex extends AppClass {
        init() {
          return __awaiter(this, void 0, void 0, function* () {
            PopupService.lastTarget = this.element;
            AppCommands.install(this);
            this.app.installStyleSheet({
              href: "https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free@6.4.0/css/all.min.css",
              integrity: "sha256-HtsXJanqjKTc8vVQjO4YMhiqFoXkfBsjBWcX91T1jr8=",
              crossOrigin: "anonymous"
            });
            yield ThisApp.isMobile ? this.mobileInit() : this.desktopInit();
            if (!Command.invokeRoute()) {
              AppCommands.home.dispatch();
            }
          });
        }
        mobileInit() {
          return __awaiter(this, void 0, void 0, function* () {
            const app = this;
            app.drawer = AppMenu;
          });
        }
        desktopInit() {
          return __awaiter(this, void 0, void 0, function* () {
            const app = this;
            app.menuRenderer = () => XNode.create(AppMenu, null);
            const year = new Date().getFullYear();
            app.statusBarRenderer = () => XNode.create("div", {
              "data-layout": "row"
            }, XNode.create("div", {
              "data-align-self": "stretch",
              "data-flex": "stretch-full",
              text: `© NeuroSpeech Technologies Pvt Ltd (India), 2012-${year}`
            }), XNode.create("i", {
              class: "fa-brands fa-github"
            }), XNode.create("a", {
              text: "github.com/web-atoms",
              href: "https://github.com/web-atoms/core",
              target: "_blank"
            }));
          });
        }
      };
      AppIndex = __decorate([Pack], AppIndex);
      _export("default", AppIndex);
    }
  };
});
//# sourceMappingURL=Index.js.map