System.register(["@web-atoms/core/dist/core/Command"], function (_export, _context) {
  "use strict";

  var Command, Commands, AppCommands;
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistCoreCommand) {
      Command = _webAtomsCoreDistCoreCommand.default;
      Commands = _webAtomsCoreDistCoreCommand.Commands;
    }],
    execute: function () {
      _export("default", AppCommands = class AppCommands extends Commands {});
      AppCommands.home = Command.create({
        route: "/",
        routeOrder: 1000,
        openPage: () => _context.import("../pages/home/HomePage")
      });
      AppCommands.introduction = Command.create({
        route: "/docs/introduction",
        openPage: () => _context.import("../pages/markdown/MDPage"),
        routeDefaults: {
          label: "Introduction",
          url: "@web-atoms/web-site/docs/general/introduction.md"
        }
      });
      AppCommands.binding = Command.create({
        route: "/docs/binding",
        openPage: () => _context.import("../pages/markdown/MDPage"),
        routeDefaults: {
          label: "Binding",
          url: "@web-atoms/web-site/docs/general/binding.md"
        }
      });
      AppCommands.dependencyInjection = Command.create({
        route: "/docs/dependency-injection",
        openPage: () => _context.import("../pages/markdown/MDPage"),
        routeDefaults: {
          label: "Binding",
          url: "@web-atoms/web-site/docs/general/dependency-injection.md"
        }
      });
      AppCommands.ajax = Command.create({
        route: "/docs/ajax-rest",
        openPage: () => _context.import("../pages/markdown/MDPage"),
        routeDefaults: {
          label: "Binding",
          url: "@web-atoms/web-site/docs/general/ajax.md"
        }
      });
      AppCommands.styledCss = Command.create({
        route: "/docs/styled-css",
        openPage: () => _context.import("../pages/markdown/MDPage"),
        routeDefaults: {
          label: "Binding",
          url: "@web-atoms/web-site/docs/web/styled.md"
        }
      });
      AppCommands.events = Command.create({
        route: "/docs/event-re-routing",
        openPage: () => _context.import("../pages/markdown/MDPage"),
        routeDefaults: {
          label: "Binding",
          url: "@web-atoms/web-site/docs/web/event-re-routing.md"
        }
      });
      AppCommands.hiring = Command.create({
        route: "/about/hiring",
        openPage: () => _context.import("../pages/markdown/MDPage"),
        routeDefaults: {
          label: "Binding",
          url: "@web-atoms/web-site/docs/general/hiring.md"
        }
      });
    }
  };
});
//# sourceMappingURL=AppCommands.js.map