System.register(["tslib", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/di/DISingleton", "@web-atoms/core/dist/services/http/RestService", "./PartialPage"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, UMD, DISingleton, BaseService, PartialPage, CodeView, MDService;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
    }, function (_webAtomsCoreDistCoreTypes) {
      UMD = _webAtomsCoreDistCoreTypes.UMD;
    }, function (_webAtomsCoreDistDiDISingleton) {
      DISingleton = _webAtomsCoreDistDiDISingleton.default;
    }, function (_webAtomsCoreDistServicesHttpRestService) {
      BaseService = _webAtomsCoreDistServicesHttpRestService.BaseService;
    }, function (_PartialPage) {
      PartialPage = _PartialPage.default;
    }],
    execute: function () {
      MDService = class MDService extends BaseService {
        getUrl(url) {
          return __awaiter(this, void 0, void 0, function* () {
            const b = this.app.createBusyIndicator();
            try {
              const a = yield this.ajax(url, {
                method: "GET"
              });
              return a.responseText;
            } finally {
              b.dispose();
            }
          });
        }
      };
      MDService = __decorate([DISingleton()], MDService);
      _export("default", CodeView = class CodeView extends PartialPage {
        constructor() {
          super(...arguments);
          this.src = null;
          this.code = null;
          this.language = null;
        }
        init() {
          return __awaiter(this, void 0, void 0, function* () {
            let src = this.src;
            if (!this.code && src) {
              if (/^\./.test(src)) {
                src = src.replace("/dist/", "/src/");
              }
              this.language = this.getLanguage(src);
              this.code = yield this.resolve(MDService).getUrl(src);
            }
            if (this.code) {
              this.app.runAsync(() => this.generate());
            }
          });
        }
        generate() {
          return __awaiter(this, void 0, void 0, function* () {
            const app = this.app;
            app.installStyleSheet("https://cdn.jsdelivr.net/npm/highlight.js@11.7.0/styles/github.min.css");
            const highlight = yield UMD.import("https://cdn.jsdelivr.net/npm/highlight.js@11.7.0/lib/index.min.js");
            const text = this.code;
            this.removeAllChildren(this.element);
            const pre = document.createElement("pre");
            const code = document.createElement("code");
            code.textContent = text.split("\n").map(s => {
              while (s.endsWith("\r")) {
                s = s.substring(0, s.length - 1);
              }
              s = s.replace(/\t/g, "   ");
              return s;
            }).join("\n");
            const language = this.language;
            pre.classList.add(language);
            pre.classList.add(`language-${language}`);
            pre.appendChild(code);
            highlight.highlightBlock(pre);
            this.element.appendChild(pre);
          });
        }
        getLanguage(path) {
          if (/\.tsx$/gi.test(path)) {
            return "typescript";
          }
          if (/\.ts$/gi.test(path)) {
            return "typescript";
          }
          if (/\.js$/gi.test(path)) {
            return "javascript";
          }
          if (/\.json$/gi.test(path)) {
            return "json";
          }
          return "plain";
        }
      });
    }
  };
});
//# sourceMappingURL=CodeView.js.map