System.register(["tslib", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/style/styled", "@web-atoms/web-controls/dist/mobile-app/MobileApp", "@web-atoms/web-controls/dist/PageNavigator", "../pages/home/HomePage", "../../images/logo.png", "../pages/markdown/MDPage", "../commands/AppCommands", "@web-atoms/core/dist/core/Route"], function (_export, _context) {
  "use strict";

  var __awaiter, XNode, styled, Drawer, PageNavigator, HomePage, logo, MDPage, AppCommands, Route, AppMenu, menuCss, MenuItem, MDMenu, css;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistStyleStyled) {
      styled = _webAtomsCoreDistStyleStyled.default;
    }, function (_webAtomsWebControlsDistMobileAppMobileApp) {
      Drawer = _webAtomsWebControlsDistMobileAppMobileApp.Drawer;
    }, function (_webAtomsWebControlsDistPageNavigator) {
      PageNavigator = _webAtomsWebControlsDistPageNavigator.default;
    }, function (_pagesHomeHomePage) {
      HomePage = _pagesHomeHomePage.default;
    }, function (_imagesLogoPng) {
      logo = _imagesLogoPng.default;
    }, function (_pagesMarkdownMDPage) {
      MDPage = _pagesMarkdownMDPage.default;
    }, function (_commandsAppCommands) {
      AppCommands = _commandsAppCommands.default;
    }, function (_webAtomsCoreDistCoreRoute) {
      Route = _webAtomsCoreDistCoreRoute.default;
    }],
    execute: function () {
      menuCss = styled.css`
    cursor: pointer;
    padding: 5px 10px 5px 10px;
    border-radius: 10px;
    text-decoration: none;
    color: var(--link-color);

    &:hover {
        background-color: lightgreen;
        text-decoration: underline;
    }
`.installLocal();
      MenuItem = ({
        label,
        icon = "",
        command,
        commandLink,
        openPage,
        pushPage,
        pageParameter,
        href
      }) => {
        if (commandLink) {
          return XNode.create("a", {
            "data-click-event": "route",
            class: menuCss,
            target: "_blank",
            href: commandLink.displayRoute({})
          }, icon && XNode.create("i", {
            class: icon
          }), label);
        }
        if (href) {
          return XNode.create("a", {
            class: menuCss,
            target: "_blank",
            href: href
          }, icon && XNode.create("i", {
            class: icon
          }), label);
        }
        return XNode.create("div", {
          class: menuCss,
          "data-layout": "row",
          "event-click": () => command ? command.dispatch() : pushPage ? PageNavigator.pushPage(pushPage, pageParameter) : PageNavigator.openPage(openPage, pageParameter)
        }, icon && XNode.create("i", {
          class: icon
        }), XNode.create("span", {
          text: label
        }));
      };
      MDMenu = ({
        label,
        url
      }) => MenuItem({
        label,
        openPage: MDPage,
        pageParameter: {
          label,
          url
        }
      });
      css = styled.css`
    width: 200px;
`.installLocal();
      _export("default", AppMenu = class AppMenu extends Drawer {
        init() {
          return __awaiter(this, void 0, void 0, function* () {
            this.renderer = XNode.create("div", {
              class: css,
              "data-layout": "vertical-flex"
            }, XNode.create("div", {
              "data-layout": "row"
            }, XNode.create("img", {
              src: logo
            }), XNode.create("div", {
              text: "Web Atoms"
            })), XNode.create(MenuItem, {
              label: "Home",
              openPage: HomePage
            }), XNode.create(MenuItem, {
              label: "Introduction",
              commandLink: AppCommands.introduction
            }), XNode.create(MenuItem, {
              label: "Binding",
              commandLink: AppCommands.binding
            }), XNode.create(MenuItem, {
              label: "Dependency Injection",
              commandLink: AppCommands.dependencyInjection
            }), XNode.create(MenuItem, {
              label: "Ajax",
              commandLink: AppCommands.ajax
            }), XNode.create(MenuItem, {
              label: "Styled Css",
              commandLink: AppCommands.styledCss
            }), XNode.create(MenuItem, {
              label: "Event Re-Routing",
              commandLink: AppCommands.events
            }), XNode.create(MenuItem, {
              label: "We Are Hiring !!",
              commandLink: AppCommands.hiring
            }), XNode.create(MenuItem, {
              label: "Blog",
              href: "/blog"
            }), XNode.create(MenuItem, {
              label: "Samples",
              href: "https://github.com/web-atoms-samples"
            }), XNode.create(MenuItem, {
              label: "Previous Versions",
              href: "/account/licenses.html"
            }));
          });
        }
      });
      Route.encodeUrl = url => {
        if (/(webatoms\.in)|(^\#)/i.test(location.href)) {
          return url;
        }
        return "#!" + url;
      };
    }
  };
});
//# sourceMappingURL=AppMenu.js.map