System.register(["tslib", "@web-atoms/core/dist/core/XNode", "@web-atoms/web-controls/dist/mobile-app/MobileApp", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/style/styled", "../../controls/AnimatedLoader", "@web-atoms/core/dist/view-model/Action"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, XNode, ContentPage, isMobileView, UMD, styled, AnimatedLoader, Action, MDPage, css, nextHeaderId;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsWebControlsDistMobileAppMobileApp) {
      ContentPage = _webAtomsWebControlsDistMobileAppMobileApp.ContentPage;
      isMobileView = _webAtomsWebControlsDistMobileAppMobileApp.isMobileView;
    }, function (_webAtomsCoreDistCoreTypes) {
      UMD = _webAtomsCoreDistCoreTypes.UMD;
    }, function (_webAtomsCoreDistStyleStyled) {
      styled = _webAtomsCoreDistStyleStyled.default;
    }, function (_controlsAnimatedLoader) {
      AnimatedLoader = _controlsAnimatedLoader.default;
    }, function (_webAtomsCoreDistViewModelAction) {
      Action = _webAtomsCoreDistViewModelAction.default;
    }],
    execute: function () {
      UMD.map("showdown", "https://cdn.jsdelivr.net/npm/showdown@1.9.0/");
      css = styled.css`
    display: grid;
    grid-template-columns: 1fr auto;
    gap: 5px;
    overflow: hidden;
    & > .md {
        overflow: auto;
        align-self: stretch;
        justify-self: stretch;

        & pre {
            border: solid 1px lightgray;
        }
    }
    & > .index {
        width: 200px;
        align-self: stretch;
        overflow: auto;
        & > * {
            margin: 5px;
            cursor: pointer;
            color: var(--link-color, blue);
            &:hover {
                text-decoration: underline;
            }
        }
    }
`.installLocal();
      nextHeaderId = 1;
      _export("default", MDPage = class MDPage extends ContentPage {
        init() {
          return __awaiter(this, void 0, void 0, function* () {
            this.title = this.parameters.label;
            this.renderer = XNode.create(AnimatedLoader, null);
            const rs = yield fetch(System.resolve(this.parameters.url));
            const code = yield rs.text();
            if (rs.status > 300) {
              this.renderer = XNode.create("div", null, XNode.create("h4", null, "Failed to load ", this.parameters.url), XNode.create("p", null, code));
              return;
            }
            this.renderer = XNode.create("div", {
              class: css
            }, XNode.create("div", {
              class: "md"
            }), !isMobileView && XNode.create("div", {
              class: "index"
            }));
            this.index = this.element.querySelector(".index");
            yield this.loadCode(code);
          });
        }
        showHeader({
          headerId
        }) {
          const e = this.element.querySelector(`#${headerId}`);
          e.scrollIntoView();
        }
        loadCode(code) {
          return __awaiter(this, void 0, void 0, function* () {
            const app = this.app;
            app.installStyleSheet("https://cdn.jsdelivr.net/npm/highlight.js@11.7.0/styles/github.min.css");
            const showdown = yield UMD.import("showdown/dist/showdown.js");
            const text = code;
            const converter = new showdown.Converter();
            converter.setOption("openLinksInNewWindow", true);
            converter.setOption("simplifiedAutoLink", true);
            const element = this.element;
            const mdRoot = element.querySelector(".md");
            const md = document.createElement("div");
            md.innerHTML = converter.makeHtml(text);
            md.style.width = "100%";
            md.style.height = "100%";
            md.className = "page";
            mdRoot.appendChild(md);
            setTimeout(() => {
              this.findHeader(md);
            }, 100);
            yield UMD.import("https://cdn.jsdelivr.net/gh/highlightjs/cdn-release@11.7.0/build/highlight.min.js");
            const highlight = window.hljs;
            const all = document.querySelectorAll("pre > code");
            for (let index = 0; index < all.length; index++) {
              const e = all[index];
              highlight.highlightBlock(e);
            }
            for (const iterator of Array.from(this.element.querySelectorAll("a"))) {
              if (/^(http|https)\:\/\//) {
                iterator.target = "_blank";
              }
            }
          });
        }
        findHeader(e) {
          if (!e) {
            return;
          }
          const all = Array.from(e.querySelectorAll("h1,h2,h3,h4,h5,h6"));
          const index = this.index;
          for (const iterator of all) {
            const id = iterator.id || (iterator.id = `nh-${nextHeaderId++}`);
            const link = document.createElement("div");
            link.className = "header";
            link.textContent = iterator.textContent;
            link.style.paddingLeft = `${parseFloat(iterator.tagName.substring(1)) * 5}px`;
            link.setAttribute("data-click-event", "show-header");
            link.setAttribute("data-header-id", id);
            index.appendChild(link);
          }
        }
      });
      __decorate([Action({
        onEvent: "show-header"
      }), __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], MDPage.prototype, "showHeader", null);
    }
  };
});
//# sourceMappingURL=MDPage.js.map