System.register([], function (_export, _context) {
  "use strict";

  function sleep(timeInMS, ct, throwOnCancel = true) {
    let token = 0;
    return new Promise((resolve, reject) => {
      ct === null || ct === void 0 ? void 0 : ct.registerForCancel(reason => {
        if (token) {
          clearTimeout(token);
          if (throwOnCancel) {
            reject(reason);
          } else {
            resolve();
          }
        }
      });
      if (ct === null || ct === void 0 ? void 0 : ct.cancelled) {
        if (throwOnCancel) {
          reject("cancelled");
        } else {
          resolve();
        }
        return;
      }
      token = setTimeout(resolve, timeInMS);
    });
  }
  _export("default", sleep);
  return {
    setters: [],
    execute: function () {}
  };
});
//# sourceMappingURL=sleep.js.map