import "reflect-metadata";
export interface INativeComponent {
    appendChild(e: any): any;
    dispatchEvent(e: any): any;
    addEventListener(name: string, fx: any, capture?: boolean): any;
    removeEventListener(name: string, fx: any, capture?: boolean): any;
}
export interface INotifyPropertyChanging {
    onPropertyChanging(name: string, newValue: any, oldValue: any): void;
}
export interface INotifyPropertyChanged {
    onPropertyChanged(name: string): void;
}
export interface IClassOf<T> extends Function {
    new (...v: any[]): T;
}
export type IAnyInstanceType<T> = T extends {
    prototype: infer U;
} ? U : any;
export type IAtomElement = HTMLElement | INativeComponent;
export interface IUIElement {
    atomControl: IUIAtomControl;
}
export interface IUIAtomControl {
    element: IUIElement;
    invalidate(): any;
    updateSize(): any;
    dispose(): any;
}
export type PathList = string[];
export interface INameValuePairs {
    [key: string]: any;
}
export interface INameValues {
    [key: string]: (string | number | boolean);
}
export interface IDisposable {
    dispose(): void;
}
export interface IRect {
    x?: number;
    y?: number;
    width?: number;
    height?: number;
}
export type CancelReason = "cancelled" | "timeout";
export declare const ignoreValue: any;
/**
 *
 *
 * @export
 * @class CancelToken
 */
export declare class CancelToken implements IDisposable {
    static isCancelled(e: any): boolean;
    private listeners;
    private mCancelled;
    get cancelled(): (CancelReason | null | undefined);
    private cancelTimeout;
    constructor(timeout?: number);
    cancel(r?: CancelReason): void;
    reset(): void;
    dispose(): void;
    registerForCancel(f: (r: CancelReason) => void): void;
}
export declare class ArrayHelper {
    static remove<T>(a: T[], filter: (item: T) => boolean): boolean;
}
declare global {
    interface IKeyedArray<TKey, T> extends Array<T> {
        key?: TKey;
    }
    interface Array<T> {
        flat(this: Array<T>, depth?: number): any[];
        groupBy?<TKey>(this: Array<T>, keySelector: ((item: T) => TKey)): Array<IKeyedArray<TKey, T>>;
    }
    interface ObjectConstructor {
        values(t: any): any[];
    }
}
export interface IUMDClass {
    debug: boolean;
    resolveViewClassAsync(path: string): Promise<any>;
    mockType(type: any, name: string): void;
    inject(type: any, name: string): void;
    resolveType(type: any): any;
    resolvePath(path: string): string;
    import<T>(path: string): Promise<T>;
}
export declare const DI: IUMDClass;
export declare const UMD: IUMDClass;
//# sourceMappingURL=types.d.ts.map