System.register(["reflect-metadata", "./AtomMap"], function (_export, _context) {
  "use strict";

  var Map, CancelToken, ArrayHelper, _a, _b, _c, ignoreValue, globalNS, DI, UMD;
  _export({
    CancelToken: void 0,
    ArrayHelper: void 0
  });
  return {
    setters: [function (_reflectMetadata) {}, function (_AtomMap) {
      Map = _AtomMap.default;
    }],
    execute: function () {
      _export("ignoreValue", ignoreValue = Symbol("ignore"));
      _export("CancelToken", CancelToken = class CancelToken {
        static isCancelled(e) {
          var _a;
          if (/^(cancelled$|canceled$|aborterror\:)/i.test((_a = e.message) !== null && _a !== void 0 ? _a : e.toString().trim())) {
            return true;
          }
          if (e.name === "AbortError") {
            return true;
          }
        }
        get cancelled() {
          return this.mCancelled;
        }
        constructor(timeout = -1) {
          this.listeners = [];
          this.mCancelled = null;
          this.cancelTimeout = null;
          if (timeout > 0) {
            this.cancelTimeout = setTimeout(() => {
              this.cancelTimeout = null;
              this.cancel("timeout");
            }, timeout);
          }
        }
        cancel(r = "cancelled") {
          this.mCancelled = r;
          const existing = this.listeners.slice(0);
          this.listeners.length = 0;
          for (const fx of existing) {
            fx(r);
          }
          this.dispose();
        }
        reset() {
          this.mCancelled = null;
          this.dispose();
        }
        dispose() {
          this.listeners.length = 0;
          if (this.cancelTimeout) {
            clearTimeout(this.cancelTimeout);
          }
        }
        registerForCancel(f) {
          if (this.mCancelled) {
            f(this.mCancelled);
            this.cancel();
            return;
          }
          this.listeners.push(f);
        }
      });
      _export("ArrayHelper", ArrayHelper = class ArrayHelper {
        static remove(a, filter) {
          for (let i = 0; i < a.length; i++) {
            const item = a[i];
            if (filter(item)) {
              a.splice(i, 1);
              return true;
            }
          }
          return false;
        }
      });
      (_a = Object.values) !== null && _a !== void 0 ? _a : Object.values = function (t) {
        const r = [];
        for (const key in t) {
          if (Object.prototype.hasOwnProperty.call(t, key)) {
            const element = t[key];
            r.push(element);
          }
        }
        return r;
      };
      (_b = (_c = Array.prototype).flat) !== null && _b !== void 0 ? _b : _c.flat = function (depth = 1) {
        const r = [];
        const flat = depth > 0;
        const nestDepth = depth - 1;
        const nestFlat = nestDepth > 0;
        for (const iterator of this) {
          if (flat && Array.isArray(iterator)) {
            if (nestFlat) {
              r.push(...iterator.flat(nestDepth));
              continue;
            }
            r.push(...iterator);
            continue;
          }
          r.push(iterator);
        }
        return r;
      };
      Array.prototype["groupBy"] = function (keySelector) {
        const map = new Map();
        const groups = [];
        for (const iterator of this) {
          const key = keySelector(iterator);
          let g = map.get(key);
          if (!g) {
            g = [];
            g.key = key;
            groups.push(g);
            map.set(key, g);
          }
          g.push(iterator);
        }
        map.clear();
        return groups;
      };
      globalNS = typeof window !== "undefined" ? window : global;
      _export("DI", DI = globalNS.UMD);
      _export("UMD", UMD = globalNS.UMD);
    }
  };
});
//# sourceMappingURL=types.js.map