export declare function buildUrl(strings: TemplateStringsArray, ...p: any[]): string;
export default class FetchBuilder {
    private readonly request;
    static get(url: any): FetchBuilder;
    static put(url: any): FetchBuilder;
    static post(url: any): FetchBuilder;
    static delete(url: any): FetchBuilder;
    static method(url: any, method: string): FetchBuilder;
    private constructor();
    form(name: string, value: string): FetchBuilder;
    jsonBody(body: any, encode?: boolean): FetchBuilder;
    header(name: string, value: string): FetchBuilder;
    path(name: string, value: any, encode?: boolean): FetchBuilder;
    query(name: string, value: any, encode?: boolean): FetchBuilder;
    responseAsText(ensureSuccess?: boolean): Promise<string>;
    responseAsBlob(ensureSuccess?: boolean): Promise<Blob>;
    responseAsJson<T>(ensureSuccess?: boolean): Promise<T>;
    response(): Promise<Response>;
    private ensureSuccess;
    private append;
}
//# sourceMappingURL=FetchBuilder.d.ts.map