import { INameValues, IRect } from "../../core/types";
export declare class AncestorEnumerator {
    static find(e: HTMLElement, filter: (e: HTMLElement) => any): HTMLElement;
    /**
     * Finds the parent element that matches given selector. It does not
     * return element that contains the selector.
     * @param e target Element
     * @param selector selector to match
     * @returns
     */
    static findSelector(e: HTMLElement, selector: string): HTMLElement;
}
export declare class ChildEnumerator {
    private e;
    static find(e: HTMLElement, filter: (e: HTMLElement) => any): HTMLElement;
    static where(e: HTMLElement, filter: (e: HTMLElement) => any): Generator<HTMLElement, void, unknown>;
    static enumerate(e: HTMLElement): Generator<HTMLElement, void, unknown>;
    private item;
    get current(): HTMLElement;
    constructor(e: HTMLElement);
    next(): boolean;
}
/**
 * Enumerate through all the descendents including self.
 * @param e Element
 */
export declare function descendentElementIterator(e: Element): Generator<Element, void, unknown>;
/**
 * Enumerate through all the descendents including self.
 * @param e Element
 */
export declare function descendentIterator(e: Node): Generator<Node, void, unknown>;
export declare class AtomUI {
    static outerHeight(el: HTMLElement, margin?: boolean): number;
    static outerWidth(el: HTMLElement, margin?: boolean): number;
    static innerWidth(el: HTMLElement): number;
    static innerHeight(el: HTMLElement): number;
    static scrollTop(el: HTMLElement, y: number): any;
    static screenOffset(e: HTMLElement): IRect;
    static parseUrl(url: string): INameValues;
    static parseValue(val: string): (number | boolean | string);
    static assignID(element: HTMLElement): string;
    static toNumber(text: string): number;
    static getNewIndex(): number;
    private static index;
}
//# sourceMappingURL=AtomUI.d.ts.map