System.register(["../../core/XNode", "../../style/styled", "./PopupService"], function (_export, _context) {
  "use strict";

  var XNode, styled, PopupWindow, css;
  function NotificationPopup({
    message,
    type
  }) {
    return class Notification extends PopupWindow {
      create() {
        if (message instanceof XNode) {
          this.render(XNode.create("div", {
            styleClass: {
              [css]: 1,
              error: /error/i.test(type),
              warning: /warn/i.test(type)
            }
          }, message));
          return;
        }
        this.render(XNode.create("div", {
          styleClass: {
            [css]: 1,
            error: /error/i.test(type),
            warning: /warn/i.test(type)
          },
          formattedText: message
        }));
      }
    };
  }
  _export("default", NotificationPopup);
  return {
    setters: [function (_coreXNode) {
      XNode = _coreXNode.default;
    }, function (_styleStyled) {
      styled = _styleStyled.default;
    }, function (_PopupService) {
      PopupWindow = _PopupService.PopupWindow;
    }],
    execute: function () {
      css = styled.css`
    padding: 5px;
    font-size: larger;
    & .error {
        color: red;
        border-color: red;
    }
    & .warning {
        background-color: lightyellow;
    }
`.installLocal();
    }
  };
});
//# sourceMappingURL=NotificationPopup.js.map