System.register(["tslib", "../../core/Bind", "../../core/BindableProperty", "../../core/XNode", "../../core/sleep", "../../core/types", "../../style/styled", "../controls/AtomControl", "../core/AtomUI"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, Bind, BindableProperty, XNode, sleep, CancelToken, styled, AtomControl, ChildEnumerator, PopupWindow, ConfirmPopup, popupService, loadPopupService, focus;
  _export({
    default: void 0,
    ConfirmPopup: void 0
  });
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_coreBind) {
      Bind = _coreBind.default;
    }, function (_coreBindableProperty) {
      BindableProperty = _coreBindableProperty.BindableProperty;
    }, function (_coreXNode) {
      XNode = _coreXNode.default;
    }, function (_coreSleep) {
      sleep = _coreSleep.default;
    }, function (_coreTypes) {
      CancelToken = _coreTypes.CancelToken;
    }, function (_styleStyled) {
      styled = _styleStyled.default;
    }, function (_controlsAtomControl) {
      AtomControl = _controlsAtomControl.AtomControl;
    }, function (_coreAtomUI) {
      ChildEnumerator = _coreAtomUI.ChildEnumerator;
    }],
    execute: function () {
      loadPopupService = () => __awaiter(void 0, void 0, void 0, function* () {
        if (popupService) {
          return popupService;
        }
        return popupService = (yield _context.import("./PopupService")).default;
      });
      focus = popup => {
        var _a, _b, _c;
        const element = popup.element;
        if (!element) {
          return;
        }
        const host = (_a = element.querySelector(`[data-window-element="title"]`)) !== null && _a !== void 0 ? _a : element.querySelector(`[data-window-element="action-bar"]`);
        if (host) {
          popup.setupDragging(host);
        }
        const anyAutofocus = element.querySelector(`*[autofocus]`);
        if (!anyAutofocus) {
          const cb = element.querySelector(".popup-close-button");
          if (cb) {
            cb.focus();
          }
          return;
        }
        (_c = (_b = anyAutofocus).focus) === null || _c === void 0 ? void 0 : _c.call(_b);
      };
      styled.css`
        position: absolute;
        border: solid 1px lightgray;
        border-radius: 5px;
        background-color: white;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        box-shadow: 0 0 20px 1px rgba(0 0 0 / 75%);

        display: grid;
        align-items: stretch;
        justify-items: stretch;
        grid-template-rows: auto auto 1fr auto;
        grid-template-columns: auto 1fr auto;
        opacity: 0;
        transition: opacity 0.3s cubic-bezier(0.55, 0.09, 0.97, 0.32) ;
        overflow: hidden;

        [data-window-modal-background=background] {
            position: absolute;
            top: 0;
            left: 0;
            bottom: 0;
            right: 0;
        }

        &[data-no-width=true] {
            max-width: 95%;
            min-width: 300px;
        }
        &[data-no-height=true] {
            max-height: 95%;
            min-height: 100px;
        }

        &[data-maximize=true] {
            width: 90%;
            height: 90%;
        }

        &[data-ready=true] {
            opacity: 1;
        }
        &[data-dragging=true] {
            opacity: 0.5;
        }
        & > [data-window-element=icon] {
            grid-row: 1;
            grid-column: 1;
            z-index: 2;
        }
        & > [data-window-element=title] {
            grid-row: 1;
            grid-column: 2;
            font-size: medium;
            overflow: hidden;
            white-space: nowrap;
            text-overflow: ellipsis;
            cursor: move;
            padding: var(--spacing, 5px);
            color: var(--accent-text-color, #424242);
            z-index: 2;
        }
        & > [data-window-element=close] {
            grid-row: 1;
            grid-column: 3;
            color: white;
            background-color: red;
            border-radius: 9999px;
            border: none;
            outline: none;
            /* padding: 5px; */
            font-family: monospace;
            height: 20px;
            width: 20px;
            margin: 5px;
            cursor: pointer;
            text-transform: capitalize;
            z-index: 2;
        }
        & > [data-window-element=action-bar] {
            grid-row: 1;
            grid-column: 1 / span 3;
            align-self: stretch;
            justify-self: stretch;
            background-color: var(--accent-color, rgba(211, 211, 211, 0.2));
            border-top-left-radius: 5px;
            border-top-right-radius: 5px;
            z-index: 1;
        }
        & > [data-window-element=header] {
            margin-top: 5px;
            grid-row: 2;
            grid-column: 1 / span 3;
        }
        & > [data-window-element=content] {
            margin-top: 5px;
            grid-row: 3;
            grid-column: 1 / span 3;
            position: relative;
            overflow: auto;
            padding: var(--spacing-medium, 7px);
            &[data-maximize=true] {
                width: 90vw;
                height: 90vh;
            }
        }
        & > [data-window-element=footer] {
            margin-top: 5px;
            grid-row: 4;
            grid-column: 1 / span 3;
            padding-top: 5px;
            padding-bottom: 5px;
            background-color: var(--command-bar-color, #80808025);

            & > button, & > * > button {
                border-radius: 9999px;
                padding: 5px;
                padding-left: 20px;
                padding-right: 20px;
                border-width: 1px;
                border-color: transparent;
                margin: 5px;
                margin-left: 10px;
            }            
        }

    `.installGlobal("[data-popup-window=popup-window]");
      _export("default", PopupWindow = class PopupWindow extends AtomControl {
        constructor() {
          super(...arguments);
          this.initialized = false;
        }
        static showWindow(window, options) {
          return __awaiter(this, arguments, void 0, function* () {
            if (arguments.length <= 1) {
              options = arguments[0];
              window = this;
            }
            yield sleep(1);
            const PS = yield loadPopupService();
            return PS.showWindow(PS.lastTarget, window, options);
          });
        }
        static showModal(window, options) {
          var _a;
          return __awaiter(this, arguments, void 0, function* () {
            if (arguments.length <= 1) {
              options = arguments[0];
              window = this;
            }
            options !== null && options !== void 0 ? options : options = {};
            (_a = options.modal) !== null && _a !== void 0 ? _a : options.modal = true;
            yield sleep(1);
            const PS = yield loadPopupService();
            return PS.showWindow(PS.lastTarget, window, options);
          });
        }
        onPropertyChanged(name) {
          super.onPropertyChanged(name);
          switch (name) {
            case "iconRenderer":
              this.recreate(name, "icon");
              break;
            case "actionBarRenderer":
              this.recreate(name, "action-bar");
              break;
            case "footerRenderer":
              this.recreate(name, "footer");
              break;
            case "titleRenderer":
              this.recreate(name, "title");
              break;
            case "headerRenderer":
              this.recreate(name, "header");
              break;
            case "closeButtonRenderer":
              this.recreate(name, "close");
              break;
          }
        }
        init() {}
        requestCancel() {
          return __awaiter(this, void 0, void 0, function* () {
            if (this.closeWarning) {
              if (!(yield ConfirmPopup.confirm({
                message: this.closeWarning
              }))) {
                return;
              }
            }
            this.cancel();
          });
        }
        recreate(renderer, name) {
          var _a, _b, _c;
          const node = (_b = (_a = this[renderer]) === null || _a === void 0 ? void 0 : _a.call(this)) !== null && _b !== void 0 ? _b : undefined;
          for (const e of ChildEnumerator.enumerate(this.element)) {
            if (e.getAttribute("data-window-element") === name) {
              this.dispose(e);
              e.remove();
              break;
            }
          }
          if (node) {
            const na = (_c = node.attributes) !== null && _c !== void 0 ? _c : node.attributes = {};
            na["data-window-element"] = name;
            super.render(XNode.create("div", null, node));
            return this.element.querySelector(`[data-window-element="${name}"]`);
          }
          return null;
        }
        rendererChanged() {
          for (const content of ChildEnumerator.where(this.element, e => e.getAttribute("data-window-element") === "content")) {
            this.dispose(content);
            content.remove();
          }
          const r = this.renderer;
          if (!r) {
            return;
          }
          delete this.render;
          this.render(r);
        }
        preCreate() {
          this.title = null;
          this.viewModelTitle = null;
          const c = new CancelToken();
          this.cancelToken = c;
          this.registerDisposable({
            dispose() {
              c.cancel();
            }
          });
          const handler = e => {
            if (e.key === "Escape") {
              this.app.runAsync(() => this.requestCancel());
              e.preventDefault();
              return;
            }
          };
          this.bindEvent(this.element, "keydown", handler);
          this.element.setAttribute("data-popup-window", "popup-window");
          setTimeout(p => {
            p.setAttribute("data-ready", "true");
          }, 10, this.element);
        }
        render(node, e, creator) {
          var _a, _b, _c, _d, _e;
          if (e || ((_a = node === null || node === void 0 ? void 0 : node.attributes) === null || _a === void 0 ? void 0 : _a["data-window-element"])) {
            super.render(node, e, creator);
            return;
          }
          this.render = super.render;
          (_b = this.titleRenderer) !== null && _b !== void 0 ? _b : this.titleRenderer = () => XNode.create("div", {
            class: "title-text",
            text: Bind.oneWay(() => this.title || this.viewModelTitle)
          });
          (_c = this.closeButtonRenderer) !== null && _c !== void 0 ? _c : this.closeButtonRenderer = () => XNode.create("button", {
            class: "popup-close-button",
            text: "x",
            eventClick: Bind.event(() => this.requestCancel())
          });
          (_d = this.actionBarRenderer) !== null && _d !== void 0 ? _d : this.actionBarRenderer = () => XNode.create("div", null);
          const a = (_e = node.attributes) !== null && _e !== void 0 ? _e : node.attributes = {};
          a["data-window-content"] = "window-content";
          a["data-window-element"] = "content";
          const extracted = this.extractControlProperties(node);
          super.render(XNode.create("div", Object.assign({
            viewModelTitle: Bind.oneWay(() => this.viewModel.title)
          }, extracted), node), e, creator);
          if (!this.initialized) {
            this.initialized = true;
            this.runAfterInit(() => {
              setTimeout(focus, 100, this);
            });
          }
        }
        setupDragging(tp) {
          this.bindEvent(tp, "mousedown", startEvent => {
            if (startEvent.target.tagName === "BUTTON") {
              return;
            }
            startEvent.preventDefault();
            const disposables = [];
            const element = this.element;
            const offset = {
              x: element.offsetLeft,
              y: element.offsetTop
            };
            if (element.style.transform !== "none") {
              offset.x -= element.offsetWidth / 2;
              offset.y -= element.offsetHeight / 2;
              element.style.left = offset.x + "px";
              element.style.top = offset.y + "px";
              element.style.transform = "none";
            }
            this.element.dataset.dragging = "true";
            const rect = {
              x: startEvent.clientX,
              y: startEvent.clientY
            };
            const cursor = tp.style.cursor;
            tp.style.cursor = "move";
            disposables.push(this.bindEvent(document.body, "mousemove", moveEvent => {
              const {
                clientX,
                clientY
              } = moveEvent;
              const dx = clientX - rect.x;
              const dy = clientY - rect.y;
              const finalX = offset.x + dx;
              const finalY = offset.y + dy;
              if (finalX < 5 || finalY < 5) {
                return;
              }
              offset.x = finalX;
              offset.y = finalY;
              this.element.style.left = offset.x + "px";
              this.element.style.top = offset.y + "px";
              rect.x = clientX;
              rect.y = clientY;
            }));
            disposables.push(this.bindEvent(document.body, "mouseup", endEvent => {
              tp.style.cursor = cursor;
              this.element.removeAttribute("data-dragging");
              for (const iterator of disposables) {
                iterator.dispose();
              }
            }));
          });
        }
      });
      __decorate([BindableProperty, __metadata("design:type", String)], PopupWindow.prototype, "title", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], PopupWindow.prototype, "titleRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], PopupWindow.prototype, "closeButtonRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], PopupWindow.prototype, "footerRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], PopupWindow.prototype, "headerRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], PopupWindow.prototype, "iconRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], PopupWindow.prototype, "actionBarRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], PopupWindow.prototype, "closeWarning", void 0);
      delete PopupWindow.prototype.init;
      styled.css`
        & >[data-window-element=content] > [data-element=details] {
            margin-top: 5px;
            overflow: auto;
            max-width: 80vw;
            max-height: 50vh;
        }
        & > [data-window-element=footer] {

            & > .yes {
                background-color: #01af01;
                color: white;
            }
            & > .no {
                background-color: red;
                color: white;
            }
            & > .cancel {
                background-color: gray;
                color: white;
            }
        }
    `.installGlobal("[data-confirm-popup=confirm-popup]");
      _export("ConfirmPopup", ConfirmPopup = class ConfirmPopup extends PopupWindow {
        static confirm({
          message,
          title = "Confirm",
          yesLabel = "Yes",
          noLabel = "No",
          cancelLabel = null
        }) {
          return __awaiter(this, void 0, void 0, function* () {
            const PS = yield loadPopupService();
            return PS.confirm({
              title,
              message,
              yesLabel,
              noLabel,
              cancelLabel
            });
          });
        }
        preCreate() {
          super.preCreate();
          this.yesLabel = "Yes";
          this.noLabel = "No";
          this.cancelLabel = null;
          this.element.setAttribute("data-confirm-popup", "confirm-popup");
          this.footerRenderer = () => XNode.create("div", null, XNode.create("button", {
            class: "yes",
            autofocus: true,
            text: Bind.oneWay(() => this.yesLabel),
            eventClick: () => this.close(true),
            "style-display": Bind.oneWay(() => !!this.yesLabel)
          }), XNode.create("button", {
            class: "no",
            text: Bind.oneWay(() => this.noLabel),
            eventClick: () => this.close(false),
            "style-display": Bind.oneWay(() => !!this.noLabel)
          }), XNode.create("button", {
            class: "cancel",
            text: Bind.oneWay(() => this.cancelLabel),
            eventClick: () => this.requestCancel(),
            "style-display": Bind.oneWay(() => !!this.cancelLabel)
          }));
          this.closeButtonRenderer = () => XNode.create("div", {
            "style-display": "none"
          });
        }
        requestCancel() {
          this.cancel();
          return Promise.resolve();
        }
      });
    }
  };
});
//# sourceMappingURL=PopupWindow.js.map