System.register(["../App", "../core/AtomBridge", "../services/BusyIndicatorService", "../services/NavigationService", "../web/styles/AtomStyleSheet", "./services/XFBusyIndicatorService", "./services/XFNavigationService"], function (_export, _context) {
  "use strict";

  var A, AtomBridge, BusyIndicatorService, NavigationService, AtomStyleSheet, XFBusyIndicatorService, XFNavigationService, XFApp;
  _export("default", void 0);
  return {
    setters: [function (_App) {
      A = _App;
    }, function (_coreAtomBridge) {
      AtomBridge = _coreAtomBridge.AtomBridge;
    }, function (_servicesBusyIndicatorService) {
      BusyIndicatorService = _servicesBusyIndicatorService.BusyIndicatorService;
    }, function (_servicesNavigationService) {
      NavigationService = _servicesNavigationService.NavigationService;
    }, function (_webStylesAtomStyleSheet) {
      AtomStyleSheet = _webStylesAtomStyleSheet.AtomStyleSheet;
    }, function (_servicesXFBusyIndicatorService) {
      XFBusyIndicatorService = _servicesXFBusyIndicatorService.default;
    }, function (_servicesXFNavigationService) {
      XFNavigationService = _servicesXFNavigationService.default;
    }],
    execute: function () {
      _export("default", XFApp = class XFApp extends A.App {
        get root() {
          return this.mRoot;
        }
        set root(v) {
          this.mRoot = v;
          bridge.setRoot(v.element);
        }
        constructor() {
          super();
          this.mLastStyle = null;
          AtomBridge.instance = bridge;
          this.put(NavigationService, this.resolve(XFNavigationService));
          this.put(BusyIndicatorService, this.resolve(XFBusyIndicatorService));
          this.put(AtomStyleSheet, new AtomStyleSheet(this, "WA_"));
          const s = bridge.subscribe((channel, data) => {
            this.broadcast(channel, data);
          });
          const oldDispose = this.dispose;
          this.dispose = () => {
            s.dispose();
            oldDispose.call(this);
          };
        }
        updateDefaultStyle(textContent) {
          if (!textContent) {
            return;
          }
          if (this.mLastStyle && this.mLastStyle === textContent) {
            return;
          }
          this.mLastStyle = textContent;
          bridge.updateDefaultStyle(textContent);
        }
        broadcast(channel, data) {
          super.broadcast(channel, data);
          bridge.broadcast(channel, data);
        }
      });
    }
  };
});
//# sourceMappingURL=XFApp.js.map