System.register(["tslib", "../../core/AtomBinder", "../../core/AtomBridge", "../../core/AtomComponent", "../../core/Bind", "../../core/XNode", "../../di/TypeKey", "../../services/NavigationService", "../../web/styles/AtomStyle", "../../web/styles/AtomStyleSheet"], function (_export, _context) {
  "use strict";

  var __awaiter, AtomBinder, AtomBridge, AtomComponent, bindSymbol, attachedProperties, attachedSymbol, constructorNeedsArgumentsSymbol, elementFactorySymbol, isControl, isFactorySymbol, isTemplateSymbol, xnodeSymbol, TypeKey, NavigationService, AtomStyle, AtomStyleSheet, AtomXFControl, defaultStyleSheets, isAtomControl, isTemplate, objectHasOwnProperty, localBindSymbol, localXNodeSymbol, elementFactory, isFactory, localBridge, renderFirst, attached, constructorNeedsArguments;
  _export("AtomXFControl", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
    }, function (_coreAtomBinder) {
      AtomBinder = _coreAtomBinder.AtomBinder;
    }, function (_coreAtomBridge) {
      AtomBridge = _coreAtomBridge.AtomBridge;
    }, function (_coreAtomComponent) {
      AtomComponent = _coreAtomComponent.AtomComponent;
    }, function (_coreBind) {
      bindSymbol = _coreBind.bindSymbol;
    }, function (_coreXNode) {
      attachedProperties = _coreXNode.attachedProperties;
      attachedSymbol = _coreXNode.attachedSymbol;
      constructorNeedsArgumentsSymbol = _coreXNode.constructorNeedsArgumentsSymbol;
      elementFactorySymbol = _coreXNode.elementFactorySymbol;
      isControl = _coreXNode.isControl;
      isFactorySymbol = _coreXNode.isFactorySymbol;
      isTemplateSymbol = _coreXNode.isTemplateSymbol;
      xnodeSymbol = _coreXNode.xnodeSymbol;
    }, function (_diTypeKey) {
      TypeKey = _diTypeKey.TypeKey;
    }, function (_servicesNavigationService) {
      NavigationService = _servicesNavigationService.NavigationService;
    }, function (_webStylesAtomStyle) {
      AtomStyle = _webStylesAtomStyle.AtomStyle;
    }, function (_webStylesAtomStyleSheet) {
      AtomStyleSheet = _webStylesAtomStyleSheet.AtomStyleSheet;
    }],
    execute: function () {
      UMD.defaultApp = "@web-atoms/core/dist/xf/XFApp";
      UMD.viewPrefix = "xf";
      AtomBridge.platform = "xf";
      defaultStyleSheets = {};
      isAtomControl = isControl;
      isTemplate = isTemplateSymbol;
      objectHasOwnProperty = Object.prototype.hasOwnProperty;
      localBindSymbol = bindSymbol;
      localXNodeSymbol = xnodeSymbol;
      elementFactory = elementFactorySymbol;
      isFactory = isFactorySymbol;
      localBridge = AtomBridge;
      renderFirst = AtomBridge.platform === "xf";
      attached = attachedSymbol;
      constructorNeedsArguments = constructorNeedsArgumentsSymbol;
      _export("AtomXFControl", AtomXFControl = class AtomXFControl extends AtomComponent {
        get controlStyle() {
          if (this.mControlStyle === undefined) {
            const key = TypeKey.get(this.defaultControlStyle || this.constructor);
            this.mControlStyle = defaultStyleSheets[key];
            if (this.mControlStyle) {
              return this.mControlStyle;
            }
            if (this.defaultControlStyle) {
              this.mControlStyle = defaultStyleSheets[key] || (defaultStyleSheets[key] = this.theme.createNamedStyle(this.defaultControlStyle, key, 0));
            }
            this.mControlStyle = this.mControlStyle || null;
          }
          return this.mControlStyle;
        }
        set controlStyle(v) {
          if (v instanceof AtomStyle) {
            this.mControlStyle = v;
          } else {
            const key = TypeKey.get(v);
            this.mControlStyle = defaultStyleSheets[key] || (defaultStyleSheets[key] = this.theme.createNamedStyle(v, key, 0));
          }
          AtomBinder.refreshValue(this, "controlStyle");
        }
        get theme() {
          return this.mTheme || this.mCachedTheme || (this.mCachedTheme = this.parent ? this.parent.theme : this.app.resolve(AtomStyleSheet, false, null));
        }
        get parent() {
          let e = this.element;
          e = e.parent;
          while (e) {
            const ac = e.atomControl;
            if (ac) {
              return ac;
            }
            e = e.parent;
          }
        }
        get factory() {
          return AtomXFControl;
        }
        atomParent(e) {
          let e1 = e;
          while (e1) {
            const ac = e1.atomControl;
            if (ac) {
              return ac;
            }
            e1 = e1.parent;
          }
        }
        append(element) {
          this.element.appendChild(element.element || element);
          return this;
        }
        invokeEvent(event) {
          AtomBridge.instance.invokeEvent(this.element, event.type, event);
        }
        staticResource(name) {
          return AtomBridge.instance.getStaticResource(this.element, name);
        }
        loadXaml(text) {
          AtomBridge.instance.loadXaml(this.element, text);
        }
        setElementValue(element, name, value) {
          if (name.startsWith(":")) {
            attachedProperties[name](element, value);
            return;
          }
          if (/^event/.test(name)) {
            this.bindEvent(element, name.substr(5), () => __awaiter(this, void 0, void 0, function* () {
              try {
                const p = value();
                if (p) {
                  yield p;
                }
              } catch (e) {
                if (/canceled|cancelled/i.test(e)) {
                  return;
                }
                const nav = this.app.resolve(NavigationService);
                nav.alert(e, "Error").catch(() => {});
              }
            }));
            return;
          }
          if (/^(class|styleClass)$/i.test(name)) {
            let classes;
            if (typeof value === "object") {
              classes = [];
              for (const key in value) {
                if (value.hasOwnProperty(key)) {
                  const e1 = value[key];
                  if (e1) {
                    classes.push(key);
                  }
                }
              }
            } else {
              classes = value.toString().split(" ");
            }
            value = classes.join(",");
            name = "class";
          }
          element[name] = value;
        }
        createNode(app, e, iterator, creator) {
          var _a;
          let name = iterator.name;
          const attributes = iterator.attributes;
          if (typeof name === "string") {
            e.appendChild(name);
            return e;
          }
          if (objectHasOwnProperty.call(name, elementFactory)) {
            if (objectHasOwnProperty.call(name, constructorNeedsArguments)) {
              const templateFactory = name[isTemplate];
              if (templateFactory) {
                const template = this.toTemplate(app, iterator, creator);
                return templateFactory(template);
              }
              const firstChild = (_a = iterator.children) === null || _a === void 0 ? void 0 : _a[0];
              const childName = firstChild === null || firstChild === void 0 ? void 0 : firstChild.name;
              let pv;
              if (childName === "WebAtoms.AtomX:Arguments") {
                pv = [];
                for (const child of firstChild.children) {
                  pv.push(this.createNode(app, e, child, creator));
                }
              } else {
                pv = iterator.children;
                name = name[constructorNeedsArguments];
              }
              const element1 = name(...pv);
              e === null || e === void 0 ? void 0 : e.appendChild(element1);
              return element1;
            }
            const element = new name();
            this.render(iterator, element, creator);
            e === null || e === void 0 ? void 0 : e.appendChild(element);
            return element;
          }
          if (name[isAtomControl]) {
            const ctrl = new name(app);
            const element = ctrl.element;
            ctrl.render(iterator, element, creator);
            e === null || e === void 0 ? void 0 : e.appendChild(element);
            return element;
          }
          const a = name[attached];
          if (a) {
            const child = this.createNode(app, null, iterator.children[0], creator);
            a(e, child);
            return e;
          }
          throw new Error(`not implemented create for ${name}`);
        }
        toTemplate(app, iterator, creator) {
          const childNode = iterator.children[0];
          const name = childNode.name;
          if (typeof name === "string") {
            throw new Error(`Creating Template from string not supported, are you missing something?`);
          }
          if (name[isAtomControl]) {
            return class Template extends name {
              constructor(a, e) {
                super(a !== null && a !== void 0 ? a : app, e);
              }
              create() {
                super.create();
                this.render(childNode, null, creator);
              }
            };
          }
          return class ElementTemplate extends AtomXFControl {
            constructor(a, e) {
              super(a !== null && a !== void 0 ? a : app, e !== null && e !== void 0 ? e : new name());
            }
            create() {
              super.create();
              this.render(childNode, null, creator);
            }
          };
        }
      });
      bridge.controlFactory = AtomXFControl;
      global.CustomEvent = function (type, {
        detail
      }) {
        this.type = type;
        this.detail = detail;
      };
    }
  };
});
//# sourceMappingURL=AtomXFControl.js.map