System.register(["tslib", "../../App", "../../core/AtomBridge", "../../core/AtomLoader", "../../core/AtomUri", "../../di/Inject", "../../di/RegisterSingleton", "../../services/JsonService", "../../services/NavigationService", "../../view-model/AtomWindowViewModel"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, __param, App, AtomBridge, AtomLoader, AtomUri, Inject, RegisterSingleton, JsonService, NavigationService, AtomWindowViewModel, XFNavigationService;
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
      __param = _tslib.__param;
    }, function (_App) {
      App = _App.App;
    }, function (_coreAtomBridge) {
      AtomBridge = _coreAtomBridge.AtomBridge;
    }, function (_coreAtomLoader) {
      AtomLoader = _coreAtomLoader.AtomLoader;
    }, function (_coreAtomUri) {
      AtomUri = _coreAtomUri.AtomUri;
    }, function (_diInject) {
      Inject = _diInject.Inject;
    }, function (_diRegisterSingleton) {
      RegisterSingleton = _diRegisterSingleton.RegisterSingleton;
    }, function (_servicesJsonService) {
      JsonService = _servicesJsonService.JsonService;
    }, function (_servicesNavigationService) {
      NavigationService = _servicesNavigationService.NavigationService;
    }, function (_viewModelAtomWindowViewModel) {
      AtomWindowViewModel = _viewModelAtomWindowViewModel.AtomWindowViewModel;
    }],
    execute: function () {
      XFNavigationService = class XFNavigationService extends NavigationService {
        get title() {
          return undefined;
        }
        set title(v) {}
        get location() {
          return new AtomUri(bridge.navigationService.getLocation());
        }
        set location(v) {
          bridge.navigationService.setLocation(v.toString());
        }
        constructor(app, jsonService) {
          super(app);
          this.jsonService = jsonService;
          this.stack = [];
        }
        alert(message, title) {
          if (typeof message !== "string") {
            message = message.toString();
          }
          return new Promise((resolve, reject) => {
            bridge.alert(message, title, () => {
              resolve();
            }, f => {
              reject(f);
            });
          });
        }
        confirm(message, title) {
          return new Promise((resolve, reject) => {
            bridge.confirm(message, title, r => {
              resolve(r);
            }, f => {
              reject(f);
            });
          });
        }
        notify(message, title, type, delay) {
          return __awaiter(this, void 0, void 0, function* () {
            console.warn("Display toast not yet implemented");
          });
        }
        navigate(url) {
          const uri = new AtomUri(url);
          this.stack.push(url);
          this.app.runAsync(() => __awaiter(this, void 0, void 0, function* () {
            const {
              view: popup
            } = yield AtomLoader.loadView(uri, this.app, true);
            bridge.setRoot(popup.element);
          }));
        }
        back() {
          if (this.stack.length) {
            const url = this.stack.pop();
            this.app.runAsync(() => __awaiter(this, void 0, void 0, function* () {
              const uri = new AtomUri(url);
              const {
                view: popup
              } = yield AtomLoader.loadView(uri, this.app, true);
              bridge.setRoot(popup.element);
            }));
          }
        }
        refresh() {
          AtomBridge.instance.reset();
        }
        openWindow(url, options) {
          return __awaiter(this, void 0, void 0, function* () {
            const {
              view: popup,
              disposables,
              returnPromise,
              id
            } = yield AtomLoader.loadView(url, this.app, true, () => this.app.resolve(AtomWindowViewModel, true));
            if (options && options.onInit) {
              options.onInit(popup);
            }
            const cancelToken = options.cancelToken;
            if (cancelToken) {
              if (cancelToken.cancelled) {
                this.app.callLater(() => {
                  this.remove(popup, true);
                });
              }
              cancelToken.registerForCancel(() => {
                this.remove(popup, true);
              });
            }
            const ve = popup.element;
            AtomBridge.instance.setValue(ve, "name", id);
            bridge.pushPage(ve, options || {}, () => {}, e => {
              this.remove(popup, true);
            });
            disposables.add(() => {
              AtomBridge.instance.popPage(ve, () => {}, e => {
                console.error(e);
              });
            });
            return returnPromise;
          });
        }
      };
      XFNavigationService = __decorate([RegisterSingleton, __param(0, Inject), __param(1, Inject), __metadata("design:paramtypes", [App, JsonService])], XFNavigationService);
      _export("default", XFNavigationService);
    }
  };
});
//# sourceMappingURL=XFNavigationService.js.map