
declare namespace JSX {
    interface IntrinsicAttributes { 
        "data-layout"?: "grid2x2" | "grid3x3" | "flex" | "flex-center" | "center-all" | "menu-item" | "vertical-flex" | "vertical-flex-center-items" | "vertical-flex-stretch-items" | "card" | /** Creates layout with content centered with vertical flex with gap. The content will stretch in mobile. */
"center-page-900px" | "flex-csv" | "flex-wrap" | "flex-wrap-padding" | "frame" | "frame-vertical-flex" | "link" | "list" | "main-list" | "grid-list" | "row" | /** Flex row with padding */
"header-row" | "command-row" | "sticky-command-row" | "toolbar-button" | "warning" | /** button: Text Button, undefined */
"button" | /** icon-button: Horizontal centered flex layout, undefined */
"icon-button" | /** accent-button: Text Button, with default accent color set by --accent-color */
"accent-button" | /** accent-icon-button: Horizontal centered flex layout, with default accent color set by --accent-color */
"accent-icon-button" | /** stop-button: Text Button, with default stop color (usually red) set by --stop-color */
"stop-button" | /** stop-icon-button: Horizontal centered flex layout, with default stop color (usually red) set by --stop-color */
"stop-icon-button" | /** go-button: Text Button, with default go color (usually green) set by --go-color */
"go-button" | /** go-icon-button: Horizontal centered flex layout, with default go color (usually green) set by --go-color */
"go-icon-button" | /** accept-button: Text Button, with default accept color (usually blue) set by --accept-color */
"accept-button" | /** accept-icon-button: Horizontal centered flex layout, with default accept color (usually blue) set by --accept-color */
"accept-icon-button" | /** warning-button: Text Button, with default warning color (usually yellow) set by --warning-color */
"warning-button" | /** warning-icon-button: Horizontal centered flex layout, with default warning color (usually yellow) set by --warning-color */
"warning-icon-button" | /** reject-button: Text Button, with default reject color (usually dark red) set by --reject-color */
"reject-button" | /** reject-icon-button: Horizontal centered flex layout, with default reject color (usually dark red) set by --reject-color */
"reject-icon-button" | "note" | "separator",
        "list-selection"?: "default",
        "data-fade"?: "bottom",
        "data-fa-font"?: "regular" | "regular-end" | "solid" | "solid-end" | "brand" | "brand-end" | "sharp" | "sharp-end",
        "data-filter"?: "drop-shadow" | "drop-shadow-white" | "drop-shadow-accent",
        "data-max-width"?: "size-xs" | "size-small" | "size-medium" | "size-large" | "size-xl" | "size-2xl" | "size-3xl" | "size-4xl" | "size-5xl" | "size-6xl" | "size-7xl" | "size-full" | "size-prose" | "screen-small" | "screen-medium" | "screen-large" | "screen-xl" | "screen-2xl" | "min-content" | "max-content" | "fit-content",
        "data-min-width"?: "size-xs" | "size-small" | "size-medium" | "size-large" | "size-xl" | "size-2xl" | "size-3xl" | "size-4xl" | "size-5xl" | "size-6xl" | "size-7xl" | "size-full" | "size-prose" | "screen-small" | "screen-medium" | "screen-large" | "screen-xl" | "screen-2xl" | "min-content" | "max-content" | "fit-content",
        "data-width"?: "size-xs" | "size-small" | "size-medium" | "size-large" | "size-xl" | "size-2xl" | "size-3xl" | "size-4xl" | "size-5xl" | "size-6xl" | "size-7xl" | "size-full" | "size-prose" | "screen-small" | "screen-medium" | "screen-large" | "screen-xl" | "screen-2xl" | "min-content" | "max-content" | "fit-content" | "auto" | "50%" | "1/3" | "2/3" | "1/6" | "5/6" | "5/12" | "25%" | "75%" | "20%" | "40%" | "60%" | "80%" | "100%" | "full-screen",
        "data-background-color"?: "red" | "blue" | "green" | "lightgreen" | "lightyellow" | "gold" | "goldenrod" | "fuchsia" | "black" | "white" | "accent" | "default" | "highlight" | "selection",
        "data-border"?: "none" | "frame" | "accent-frame",
        "data-border-style"?: "solid" | "dashed" | "dotted" | "double" | "groove" | "inset" | "none" | "outset" | "ridge",
        "data-border-width"?: "thin" | "thick" | "thinner" | "thicker" | "thinnest" | "thickest",
        "data-border-color"?: "accent",
        "data-border-radius"?: "full",
        "data-border-left-style"?: "solid" | "dashed" | "dotted" | "double" | "groove" | "inset" | "none" | "outset" | "ridge",
        "data-border-left-width"?: "thin" | "thick" | "thinner" | "thicker" | "thinnest" | "thickest",
        "data-border-left-color"?: "accent",
        "data-border-right-style"?: "solid" | "dashed" | "dotted" | "double" | "groove" | "inset" | "none" | "outset" | "ridge",
        "data-border-right-width"?: "thin" | "thick" | "thinner" | "thicker" | "thinnest" | "thickest",
        "data-border-right-color"?: "accent",
        "data-border-top-style"?: "solid" | "dashed" | "dotted" | "double" | "groove" | "inset" | "none" | "outset" | "ridge",
        "data-border-top-width"?: "thin" | "thick" | "thinner" | "thicker" | "thinnest" | "thickest",
        "data-border-top-color"?: "accent",
        "data-border-bottom-style"?: "solid" | "dashed" | "dotted" | "double" | "groove" | "inset" | "none" | "outset" | "ridge",
        "data-border-bottom-width"?: "thin" | "thick" | "thinner" | "thicker" | "thinnest" | "thickest",
        "data-border-bottom-color"?: "accent",
        "data-border-top-left-radius"?: "full",
        "data-border-bottom-left-radius"?: "full",
        "data-border-top-right-radius"?: "full",
        "data-border-bottom-right-radius"?: "full",
        "data-color"?: "red" | "blue" | "green" | "lightgreen" | "lightyellow" | "gold" | "goldenrod" | "fuchsia" | "black" | "white" | "default" | "highlight" | "selection" | "accent",
        "data-cursor"?: "auto" | "default" | "nope" | "context-menu" | "help" | "pointer" | "progress" | "wait" | "cell" | "crosshair" | "text" | "vertical-text" | "alias" | "copy" | "move" | "no-drop" | "not-allowed" | "grab" | "grabbing" | "e-resize" | "n-resize" | "ne-resize" | "nw-resize" | "s-resize" | "se-resize" | "sw-resize" | "w-resize" | "ew-resize" | "ns-resize" | "nesw-resize" | "nwse-resize" | "col-resize" | "row-resize" | "all-scroll" | "zoom-in" | "zoom-out" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-display"?: "flex" | "grid" | "inline-grid" | "inline-flex" | "vertical-flex" | "none",
        "data-flex"?: "stretch-full" | "stretch-half" | "stretch-quarter" | "stretch-three-fourth",
        "data-font-size"?: "small" | "medium" | "large",
        "data-font-style"?: "italic" | "normal" | "oblique",
        "data-font-weight"?: "bold" | "normal" | "bolder" | "lighter",
        "data-grid-row"?: "1" | "2" | "3" | "4" | "5" | "1 / span 2" | "2 / span 2" | "3 / span 2" | "4 / span 2" | "5 / span 2" | "1 / span 3" | "2 / span 3" | "3 / span 3" | "4 / span 3" | "5 / span 3" | "1 / span 4" | "2 / span 4" | "3 / span 4" | "4 / span 4" | "5 / span 4" | "1 / span 5" | "2 / span 5" | "3 / span 5" | "4 / span 5" | "5 / span 5",
        "data-grid-column"?: "1" | "2" | "3" | "4" | "5" | "1 / span 2" | "2 / span 2" | "3 / span 2" | "4 / span 2" | "5 / span 2" | "1 / span 3" | "2 / span 3" | "3 / span 3" | "4 / span 3" | "5 / span 3" | "1 / span 4" | "2 / span 4" | "3 / span 4" | "4 / span 4" | "5 / span 4" | "1 / span 5" | "2 / span 5" | "3 / span 5" | "4 / span 5" | "5 / span 5",
        "data-grid-row-span"?: "2" | "3" | "4",
        "data-grid-column-span"?: "2" | "3" | "4",
        "data-align-content"?: "center" | "start" | "end" | "flex-start" | "flex-end" | "normal" | "baseline" | "space-between" | "space-around" | "space-evenly" | "stretch" | "safe-center" | "unsafe-center" | "first-baseline" | "last-baseline" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-align-items"?: "normal" | "stretch" | "center" | "start" | "end" | "flex-start" | "flex-end" | "self-start" | "self-end" | "baseline" | "first-baseline" | "last-baseline" | "safe-center" | "unsafe-center" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-align-self"?: "normal" | "auto" | "center" | "start" | "end" | "self-start" | "self-end" | "flex-start" | "flex-end" | "baseline" | "first-baseline" | "last-baseline" | "stretch" | "safe-center" | "unsafe-center" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-justify-content"?: "center" | "start" | "end" | "flex-start" | "flex-end" | "left" | "right" | "normal" | "space-between" | "space-around" | "space-evenly" | "stretch" | "safe-center" | "unsafe-center" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-justify-items"?: "normal" | "stretch" | "center" | "start" | "end" | "flex-start" | "flex-end" | "self-start" | "self-end" | "left" | "right" | "baseline" | "first-baseline" | "last-baseline" | "safe-center" | "unsafe-center" | "legacy-right" | "legacy-left" | "legacy-center" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-justify-self"?: "auto" | "normal" | "stretch" | "center" | "start" | "end" | "flex-start" | "flex-end" | "self-start" | "self-end" | "left" | "right" | "baseline" | "first-baseline" | "last-baseline" | "safe-center" | "unsafe-center" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-overflow"?: "hidden" | "auto" | "scroll" | "visible",
        "data-overflow-x"?: "hidden" | "auto" | "scroll" | "visible",
        "data-overflow-y"?: "hidden" | "auto" | "scroll" | "visible",
        "data-padding"?: "auto" | "medium" | "large" | "small" | "none" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-padding-left"?: "auto" | "medium" | "large" | "small" | "none" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-padding-right"?: "auto" | "medium" | "large" | "small" | "none" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-padding-top"?: "auto" | "medium" | "large" | "small" | "none" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-padding-bottom"?: "auto" | "medium" | "large" | "small" | "none" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-margin"?: "auto" | "default" | "medium" | "large" | "small" | "none" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-margin-left"?: "auto" | "default" | "medium" | "large" | "small" | "none" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-margin-right"?: "auto" | "default" | "medium" | "large" | "small" | "none" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-margin-top"?: "auto" | "default" | "medium" | "large" | "small" | "none" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-margin-bottom"?: "auto" | "default" | "medium" | "large" | "small" | "none" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-position"?: "sticky" | "sticky-top" | "sticky-bottom" | "static" | "absolute" | "absolute-fill" | "relative",
        "data-text-align"?: "left" | "right" | "center" | "justify",
        "data-text-decoration"?: "underline" | "overline" | "strike-through" | "line-through" | "wavy" | "none" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-text-overflow"?: "ellipsis",
        "data-text-transform"?: "none" | "capitalize" | "uppercase" | "lowercase" | "full-width" | "full-size-kana" | "inherit" | "initial" | "revert" | "revert-layer" | "unset",
        "data-wrap"?: "none",
    }
}
