System.register(["tslib", "../models/Cloner", "../models/IEntityModel", "./HttpSession", "./mergeProperties", "./Query", "./resolve"], function (_export, _context) {
  "use strict";

  var __awaiter, Cloner, EntityContext, HttpSession, mergeProperties, Query, resolve, Model, BaseEntityService, ArrayPrototype;
  _export({
    Model: void 0,
    default: void 0
  });
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
    }, function (_modelsCloner) {
      Cloner = _modelsCloner.Cloner;
    }, function (_modelsIEntityModel) {
      EntityContext = _modelsIEntityModel.EntityContext;
    }, function (_HttpSession) {
      HttpSession = _HttpSession.default;
    }, function (_mergeProperties) {
      mergeProperties = _mergeProperties.default;
    }, function (_Query) {
      Query = _Query.default;
    }, function (_resolve) {
      resolve = _resolve.default;
    }],
    execute: function () {
      ArrayPrototype = Array.prototype;
      ArrayPrototype.where = ArrayPrototype.filter;
      ArrayPrototype.any = ArrayPrototype.some;
      ArrayPrototype.select = ArrayPrototype.map;
      ArrayPrototype.selectMany = function (x) {
        const r = [];
        for (const iterator of this) {
          const items = x(iterator);
          if (Array.isArray(items)) {
            r.push(...items);
          }
        }
        return r;
      };
      ArrayPrototype.firstOrDefault = function (f) {
        if (f) {
          return ArrayPrototype.find.apply(this, arguments);
        }
        return this[0];
      };
      ArrayPrototype.sum = function (f) {
        var _a;
        let n = 0;
        for (const iterator of this) {
          n += (_a = f(iterator)) !== null && _a !== void 0 ? _a : 0;
        }
        return n;
      };
      ArrayPrototype.average = function (f) {
        var _a;
        if (this.length === 0) {
          return 0;
        }
        let n = 0;
        for (const iterator of this) {
          n += (_a = f(iterator)) !== null && _a !== void 0 ? _a : 0;
        }
        return n / this.length;
      };
      ArrayPrototype.orderBy = function (f) {
        return this.sort((a, b) => {
          const ak = f(a);
          const bk = f(b);
          if (typeof ak === "string") {
            return ak.toLowerCase().localeCompare(bk.toLowerCase());
          }
          return ak - bk;
        });
      };
      ArrayPrototype.thenBy = ArrayPrototype.orderBy;
      ArrayPrototype.orderByDescending = function (f) {
        return this.sort((a, b) => {
          const ak = f(a);
          const bk = f(b);
          if (typeof ak === "string") {
            return bk.toLowerCase().localeCompare(ak.toLowerCase());
          }
          return bk - ak;
        });
      };
      ArrayPrototype.thenByDescending = ArrayPrototype.orderByDescending;
      ArrayPrototype.count = function (f) {
        if (!f) {
          return this.length;
        }
        let length = 0;
        for (const iterator of this) {
          if (f(iterator)) {
            length++;
          }
        }
        return length;
      };
      _export("Model", Model = class Model {
        constructor(name) {
          this.name = name;
        }
        create(properties = {}) {
          properties.$type = this.name;
          return properties;
        }
      });
      _export("default", BaseEntityService = class BaseEntityService extends HttpSession {
        constructor() {
          super(...arguments);
          this.url = "/api/entity/";
          this.resultConverter = resolve;
        }
        cloner(item) {
          return new Cloner(item);
        }
        model() {
          return __awaiter(this, void 0, void 0, function* () {
            if (this.entityModel) {
              return this.entityModel;
            }
            const c = yield this.getJson({
              url: `${this.url}model`
            });
            this.entityModel = new EntityContext(c);
            return this.entityModel;
          });
        }
        dateRange(start, end, step) {
          return new Query({
            service: this,
            name: "NeuroSpeech.EntityAccessControl.DateRange",
            traceQuery: false
          }, [["dateRange", "@0,@1,@2", start, end, step]]);
        }
        query(m, queryFunction, ...args) {
          return new Query({
            service: this,
            name: m.name,
            queryFunction,
            args
          });
        }
        delete(body) {
          const url = this.url;
          return this.deleteJson({
            url,
            body
          });
        }
        insert(body) {
          const url = this.url;
          return this.putJson({
            url,
            body
          });
        }
        save(body) {
          return __awaiter(this, void 0, void 0, function* () {
            if (Array.isArray(body) && body.length === 0) {
              return body;
            }
            const url = this.url;
            const result = yield this.postJson({
              url,
              body
            });
            mergeProperties(result, body);
            return body;
          });
        }
        update(e, update) {
          return __awaiter(this, void 0, void 0, function* () {
            yield this.bulkUpdate([e], update);
            for (const key in update) {
              if (Object.prototype.hasOwnProperty.call(update, key)) {
                const element = update[key];
                e[key] = element;
              }
            }
            return e;
          });
        }
        bulkUpdate(entities, update, throwWhenNotFound = false) {
          return __awaiter(this, void 0, void 0, function* () {
            const model = yield this.model();
            const keys = [];
            for (const iterator of entities) {
              const entityType = model.for(iterator.$type);
              const key = {
                $type: iterator.$type
              };
              for (const {
                name
              } of entityType.keys) {
                key[name] = iterator[name];
              }
              keys.push(key);
            }
            const body = {
              keys,
              update,
              throwWhenNotFound
            };
            const url = `${this.url}bulk`;
            yield this.putJson({
              url,
              body
            });
          });
        }
        bulkDelete(entities, throwWhenNotFound = false) {
          return __awaiter(this, void 0, void 0, function* () {
            const model = yield this.model();
            const keys = [];
            for (const iterator of entities) {
              const entityType = model.for(iterator.$type);
              const key = {
                $type: iterator.$type
              };
              for (const {
                name
              } of entityType.keys) {
                key[name] = iterator[name];
              }
              keys.push(key);
            }
            const url = `${this.url}bulk`;
            const body = {
              keys,
              throwWhenNotFound
            };
            yield this.deleteJson({
              url,
              body
            });
          });
        }
        fetchJson(options) {
          const _super = Object.create(null, {
            fetchJson: {
              get: () => super.fetchJson
            }
          });
          return __awaiter(this, void 0, void 0, function* () {
            if (!BaseEntityService.busyIndicatorFactory || (options === null || options === void 0 ? void 0 : options.hideActivityIndicator)) {
              return yield _super.fetchJson.call(this, options);
            }
            const disposable = BaseEntityService.busyIndicatorFactory({
              title: options.url
            });
            try {
              return yield _super.fetchJson.call(this, options);
            } finally {
              disposable === null || disposable === void 0 ? void 0 : disposable.dispose();
            }
          });
        }
      });
    }
  };
});
//# sourceMappingURL=BaseEntityService.js.map