System.register([], function (_export, _context) {
  "use strict";

  var CacheMap;
  _export("default", void 0);
  return {
    setters: [],
    execute: function () {
      _export("default", CacheMap = class CacheMap {
        constructor(clearInterval = 15000) {
          this.clearInterval = clearInterval;
          this.cache = new Map();
        }
        getOrCreate(key, factory) {
          const now = Date.now();
          let r = this.cache.get(key);
          if (r === void 0) {
            r = {
              access: now,
              value: factory(key)
            };
            this.cache.set(key, r);
          }
          r.access = now;
          if (!this.timer) {
            this.timer = setTimeout(this.clear, this.clearInterval, this);
          }
          return r.value;
        }
        clear() {
          const max = Date.now() - this.clearInterval;
          const toDelete = [];
          for (const [key, value] of this.cache.entries()) {
            if (value.access > max) {
              continue;
            }
            toDelete.push(key);
          }
          for (const iterator of toDelete) {
            this.cache.delete(iterator);
          }
          if (this.cache.size == 0) {
            this.timer = false;
          } else {
            this.timer = setTimeout(this.clear, this.clearInterval, this);
          }
        }
      });
    }
  };
});
//# sourceMappingURL=CacheMap.js.map