import { CancelToken } from "@web-atoms/core/dist/core/types";
export type URIWithSearchParams = [string, {
    [k: string]: any;
}];
export type StringOrURIWithSearchParams = string | URIWithSearchParams;
export declare function merge(url: string, extra: StringOrURIWithSearchParams): string;
export declare function combine([url, params]: URIWithSearchParams): string;
export declare class TextBody {
    readonly text: string;
    constructor(text: string);
    toString(): string;
}
export interface IHttpRequest extends RequestInit {
    url: string;
    method?: string;
    headers?: any;
    body?: any;
    cancelToken?: CancelToken;
    hideActivityIndicator?: boolean;
}
export default class HttpSession {
    protected resultConverter: (e: any) => any;
    protected fetchJson<T>(options: IHttpRequest): Promise<T>;
    protected interceptFetch(input: RequestInfo | URL, init?: RequestInit): Promise<Response>;
    protected getJson<T>(options: IHttpRequest): Promise<T>;
    protected postFormModel<T>(options: IHttpRequest): Promise<T>;
    protected postJson<T>(options: IHttpRequest): Promise<T>;
    protected deleteJson<T>(options: IHttpRequest): Promise<T>;
    protected putJson<T>(options: IHttpRequest): Promise<T>;
}
//# sourceMappingURL=HttpSession.d.ts.map