System.register(["tslib", "@web-atoms/core/dist/services/http/JsonError"], function (_export, _context) {
  "use strict";

  var __awaiter, JsonError, TextBody, HttpSession;
  function merge(url, extra) {
    return url + (typeof extra === "string" ? extra : combine(extra));
  }
  function combine([url, params]) {
    let separator = url.indexOf("?") === -1 ? "?" : "&";
    if (!url.endsWith("&")) {
      url += separator;
      separator = "";
    }
    for (const key in params) {
      if (params.hasOwnProperty(key)) {
        const element = params[key];
        url += separator;
        separator = "&";
        url += `${key}=${encodeURIComponent(element)}`;
      }
    }
    return url;
  }
  _export({
    merge: merge,
    combine: combine,
    TextBody: void 0,
    default: void 0
  });
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
    }, function (_webAtomsCoreDistServicesHttpJsonError) {
      JsonError = _webAtomsCoreDistServicesHttpJsonError.default;
    }],
    execute: function () {
      _export("TextBody", TextBody = class TextBody {
        constructor(text) {
          this.text = text;
        }
        toString() {
          return this.text;
        }
      });
      _export("default", HttpSession = class HttpSession {
        constructor() {
          this.resultConverter = e => e;
        }
        fetchJson(options) {
          var _a, _b, _c, _d, _e, _f;
          return __awaiter(this, void 0, void 0, function* () {
            if (options.cancelToken) {
              const ab = new AbortController();
              options.signal = ab.signal;
              options.cancelToken.registerForCancel(() => {
                ab.abort();
              });
            }
            let response;
            ;
            if (this.interceptFetch) {
              response = yield this.interceptFetch(options.url, options);
            } else {
              response = yield fetch(options.url, options);
            }
            const contentType = (_a = response.headers.get("Content-Type")) === null || _a === void 0 ? void 0 : _a.toString();
            if (response.status >= 400) {
              if (contentType && !contentType.includes("/json")) {
                const error = yield response.json();
                throw new JsonError(typeof response === "string" ? response : (_f = (_e = (_d = (_c = (_b = error.title) !== null && _b !== void 0 ? _b : error.detail) !== null && _c !== void 0 ? _c : error.message) !== null && _d !== void 0 ? _d : error.exceptionMessage) !== null && _e !== void 0 ? _e : error) !== null && _f !== void 0 ? _f : "Json Server Error", error);
              }
              throw new Error(yield response.text());
            }
            if (contentType && !contentType.includes("/json")) {
              throw new Error(`Unable to convert to json\r\n${contentType}}`);
            }
            return this.resultConverter(yield response.json());
          });
        }
        interceptFetch(input, init) {
          throw new Error("not supported");
        }
        getJson(options) {
          options.method = "GET";
          return this.fetchJson(options);
        }
        postFormModel(options) {
          var _a;
          options.method = "POST";
          if (options.body) {
            options.body = new TextBody(`formModel=${encodeURIComponent(JSON.stringify(options.body))}`);
          }
          (_a = options.headers) !== null && _a !== void 0 ? _a : options.headers = {};
          options.headers["content-type"] = "application/x-www-form-urlencoded";
          return this.fetchJson(options);
        }
        postJson(options) {
          var _a;
          options.method = "POST";
          if (options.body) {
            options.body = JSON.stringify(options.body);
          }
          (_a = options.headers) !== null && _a !== void 0 ? _a : options.headers = {};
          options.headers["content-type"] = "application/json";
          return this.fetchJson(options);
        }
        deleteJson(options) {
          var _a;
          options.method = "DELETE";
          if (options.body) {
            options.body = JSON.stringify(options.body);
          }
          (_a = options.headers) !== null && _a !== void 0 ? _a : options.headers = {};
          options.headers["content-type"] = "application/json";
          return this.fetchJson(options);
        }
        putJson(options) {
          var _a;
          options.method = "PUT";
          if (options.body) {
            options.body = JSON.stringify(options.body);
          }
          (_a = options.headers) !== null && _a !== void 0 ? _a : options.headers = {};
          options.headers["content-type"] = "application/json";
          return this.fetchJson(options);
        }
      });
      delete HttpSession.prototype.interceptFetch;
    }
  };
});
//# sourceMappingURL=HttpSession.js.map