System.register(["@web-atoms/unit-test/dist/TestRunner"], function (_export, _context) {
  "use strict";

  var TestRunner, statSync, readdirSync, path, instance;
  function loadScripts(start) {
    for (const item of readdirSync(start)) {
      const file = `${start}/${item}`;
      const s = statSync(file);
      if (s.isDirectory()) {
        loadScripts(file);
        continue;
      }
      if (file.endsWith(".js")) {
        const md = file.substr(0, file.length - 3);
        require("." + md);
      }
    }
  }
  return {
    setters: [function (_webAtomsUnitTestDistTestRunner) {
      TestRunner = _webAtomsUnitTestDistTestRunner.default;
    }],
    execute: function () {
      ({
        statSync,
        readdirSync
      } = require("fs"));
      path = require("path");
      loadScripts("./dist/tests");
      instance = TestRunner.instance;
      instance.run().then(() => {
        process.exit();
      }).catch(e => {
        console.error(e.message);
        if (e.stack) {
          console.error(e.stack);
        }
        process.exit(1);
      });
    }
  };
});
//# sourceMappingURL=test.js.map