System.register(["tslib", "@web-atoms/unit-test/dist/Assert", "@web-atoms/unit-test/dist/Test", "@web-atoms/unit-test/dist/TestItem", "../../CastAs", "../../EF", "../../services/Query"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, Assert, Test, TestItem, CastAs, EF, convertToLinq, ReplacerTests, match;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsUnitTestDistAssert) {
      Assert = _webAtomsUnitTestDistAssert.default;
    }, function (_webAtomsUnitTestDistTest) {
      Test = _webAtomsUnitTestDistTest.default;
    }, function (_webAtomsUnitTestDistTestItem) {
      TestItem = _webAtomsUnitTestDistTestItem.default;
    }, function (_CastAs) {
      CastAs = _CastAs.default;
    }, function (_EF) {
      EF = _EF.default;
    }, function (_servicesQuery) {
      convertToLinq = _servicesQuery.convertToLinq;
    }],
    execute: function () {
      match = (expected, result) => {
        Assert.equals(expected, convertToLinq(result.toString()));
      };
      _export("default", ReplacerTests = class ReplacerTests extends TestItem {
        replaceEFFunctions() {
          match(`(x) => CastAs.String(x.TagType) == "a"`, x => CastAs.string(x.tagType) === "a");
          match(`(x) => CastAs.String(x.TagType) == "a" && EF.Functions.IsDate(x.Date)`, x => CastAs.string(x.tagType) === "a" && EF.functions.isDate(x.date));
        }
        replaceSelect() {
          match(`(x) => ( new { name = x.FirstName, email = x.EmailAddress })`, x => ({
            name: x.firstName,
            email: x.emailAddress
          }));
        }
        replaceSelectNested() {
          match(`(x) => ( new { name = x.FirstName, email = ( new { address = x.EmailAddress }) })`, x => ({
            name: x.firstName,
            email: {
              address: x.emailAddress
            }
          }));
        }
        replaceSelectNestedMinified() {
          match(`(x) => ( new { name = x.FirstName, email = new { address = x.EmailAddress } })`, x => ({
            name: x.firstName,
            email: {
              address: x.emailAddress
            }
          }));
        }
        replaceMethods() {
          match(`(x) => x.Files.Any((f) => f.Name.StartsWith("image"))`, x => x.files.any(f => f.name.startsWith("image")));
          match(`(x) => x.Files.Any((f) => f.Name.StartsWith("image"))`, x => x.files.some(f => f.name.startsWith("image")));
        }
      });
      __decorate([Test, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ReplacerTests.prototype, "replaceEFFunctions", null);
      __decorate([Test, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ReplacerTests.prototype, "replaceSelect", null);
      __decorate([Test, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ReplacerTests.prototype, "replaceSelectNested", null);
      __decorate([Test, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ReplacerTests.prototype, "replaceSelectNestedMinified", null);
      __decorate([Test, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], ReplacerTests.prototype, "replaceMethods", null);
    }
  };
});
//# sourceMappingURL=ReplacerTests.js.map