System.register(["tslib", "@web-atoms/core/dist/di/Inject", "@web-atoms/core/dist/view-model/Action", "@web-atoms/core/dist/view-model/AtomWindowViewModel", "@web-atoms/core/dist/view-model/Load", "../../services/BaseEntityService"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, Inject, Action, AtomWindowViewModel, Load, EntityService, EditorViewModel;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistDiInject) {
      Inject = _webAtomsCoreDistDiInject.Inject;
    }, function (_webAtomsCoreDistViewModelAction) {
      Action = _webAtomsCoreDistViewModelAction.default;
    }, function (_webAtomsCoreDistViewModelAtomWindowViewModel) {
      AtomWindowViewModel = _webAtomsCoreDistViewModelAtomWindowViewModel.AtomWindowViewModel;
    }, function (_webAtomsCoreDistViewModelLoad) {
      Load = _webAtomsCoreDistViewModelLoad.default;
    }, function (_servicesBaseEntityService) {
      EntityService = _servicesBaseEntityService.default;
    }],
    execute: function () {
      _export("default", EditorViewModel = class EditorViewModel extends AtomWindowViewModel {
        constructor() {
          super(...arguments);
          this.name = "";
          this.keys = [];
          this.value = [];
        }
        loadAsync() {
          return __awaiter(this, void 0, void 0, function* () {
            const model = this.model;
            const entityContext = yield this.entityService.model();
            const entityModel = entityContext.for(model.$type);
            this.name = this.insert ? `Add ${model.$type}` : `Modify ${model.$type}`;
            const keys = this.keys;
            keys.clear();
            for (const e of entityModel.keys) {
              if (!this.insert && !Object.prototype.hasOwnProperty.call(model, e.name)) {
                continue;
              }
              const value = model[e.name];
              keys.push({
                name: e.name,
                value,
                required: true,
                readonly: !this.insert
              });
            }
            const values = this.value;
            values.clear();
            for (const e of entityModel.properties) {
              if (!this.insert && !Object.prototype.hasOwnProperty.call(model, e.name)) {
                continue;
              }
              const value = model[e.name];
              values.push({
                name: e.name,
                value,
                required: !e.isNullable,
                readonly: false
              });
            }
          });
        }
        save() {
          return __awaiter(this, void 0, void 0, function* () {
            let model = {
              $type: this.model.$type
            };
            for (const iterator of this.keys) {
              model[iterator.name] = iterator.value;
            }
            for (const iterator of this.value) {
              model[iterator.name] = iterator.value;
            }
            if (this.insert) {
              model = yield this.entityService.insert(model);
            } else {
              model = yield this.entityService.save(model);
            }
            this.close(model);
          });
        }
        delete(a) {
          this.value.remove(a);
          this.keys.remove(a);
        }
      });
      __decorate([Inject, __metadata("design:type", EntityService)], EditorViewModel.prototype, "entityService", void 0);
      __decorate([Load({
        init: true
      }), __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", Promise)], EditorViewModel.prototype, "loadAsync", null);
      __decorate([Action(), __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", Promise)], EditorViewModel.prototype, "save", null);
    }
  };
});
//# sourceMappingURL=EditorViewModel.js.map