System.register(["@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomComboBox", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/web/controls/AtomItemsControl", "../edit/Editor", "./TableListViewModel"], function (_export, _context) {
  "use strict";

  var Bind, XNode, AtomComboBox, AtomControl, AtomItemsControl, Editor, TableListViewModel, TableList, BindEntity;
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomComboBox) {
      AtomComboBox = _webAtomsCoreDistWebControlsAtomComboBox.AtomComboBox;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistWebControlsAtomItemsControl) {
      AtomItemsControl = _webAtomsCoreDistWebControlsAtomItemsControl.AtomItemsControl;
    }, function (_editEditor) {
      Editor = _editEditor.default;
    }, function (_TableListViewModel) {
      TableListViewModel = _TableListViewModel.default;
    }],
    execute: function () {
      BindEntity = Bind.forData();
      _export("default", TableList = class TableList extends AtomControl {
        create() {
          this.viewModel = this.resolve(TableListViewModel);
          this.render(XNode.create("div", null, XNode.create(AtomComboBox, {
            items: Bind.oneWay(() => this.viewModel.tables),
            value: Bind.twoWays(() => this.viewModel.table)
          }), XNode.create("input", {
            placeholder: `Valid Lambda Expression e.g. x => x.Key === "a"`,
            type: "search",
            value: Bind.twoWays(() => this.viewModel.search)
          }), XNode.create("button", {
            eventClick: Bind.event(() => this.viewModel.refreshSearch()),
            text: "Search"
          }), XNode.create("button", {
            eventClick: Bind.event(() => this.viewModel.add(Editor)),
            text: "Add"
          }), XNode.create("table", null, XNode.create("thead", null, XNode.create("tr", null, XNode.create("th", null, "Type"), XNode.create("th", null, "Values"), XNode.create("th", null, "Edit"), XNode.create("th", null, "Delete"))), XNode.create(AtomItemsControl, {
            for: "tbody",
            items: Bind.oneWay(() => this.viewModel.list.items)
          }, XNode.create(AtomItemsControl.itemTemplate, null, XNode.create("tr", null, XNode.create("td", {
            text: BindEntity.oneWay(x => x.data.$type)
          }), XNode.create("td", {
            text: BindEntity.oneWay(x => JSON.stringify(x.data))
          }), XNode.create("td", null, XNode.create("button", {
            eventClick: BindEntity.event(e => this.viewModel.edit(Editor, e.data)),
            text: "Edit"
          })), XNode.create("td", null, XNode.create("button", {
            eventClick: BindEntity.event(e => this.viewModel.delete(e.data)),
            text: "Delete"
          }))))), XNode.create("tfoot", null, XNode.create("tr", null, XNode.create("td", {
            colSpan: "5"
          }, XNode.create("span", {
            text: "Total: "
          }), XNode.create("span", {
            text: Bind.oneWay(() => this.viewModel.list.total)
          })))))));
        }
      });
    }
  };
});
//# sourceMappingURL=TableList.js.map