System.register(["tslib", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/di/Inject", "@web-atoms/core/dist/services/NavigationService", "@web-atoms/core/dist/services/ReferenceService", "@web-atoms/core/dist/view-model/Action", "@web-atoms/core/dist/view-model/AtomViewModel", "@web-atoms/core/dist/view-model/Load", "../../services/BaseEntityService"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, CancelToken, Inject, NavigationService, ReferenceService, Action, AtomViewModel, Load, EntityService, TableListViewModel;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreTypes) {
      CancelToken = _webAtomsCoreDistCoreTypes.CancelToken;
    }, function (_webAtomsCoreDistDiInject) {
      Inject = _webAtomsCoreDistDiInject.Inject;
    }, function (_webAtomsCoreDistServicesNavigationService) {
      NavigationService = _webAtomsCoreDistServicesNavigationService.NavigationService;
    }, function (_webAtomsCoreDistServicesReferenceService) {
      ReferenceService = _webAtomsCoreDistServicesReferenceService.default;
    }, function (_webAtomsCoreDistViewModelAction) {
      Action = _webAtomsCoreDistViewModelAction.default;
    }, function (_webAtomsCoreDistViewModelAtomViewModel) {
      AtomViewModel = _webAtomsCoreDistViewModelAtomViewModel.AtomViewModel;
    }, function (_webAtomsCoreDistViewModelLoad) {
      Load = _webAtomsCoreDistViewModelLoad.default;
    }, function (_servicesBaseEntityService) {
      EntityService = _servicesBaseEntityService.default;
    }],
    execute: function () {
      _export("default", TableListViewModel = class TableListViewModel extends AtomViewModel {
        constructor() {
          super(...arguments);
          this.version = 0;
          this.tables = [];
          this.filter = {
            start: 0,
            size: 100,
            filter: null
          };
        }
        load() {
          return __awaiter(this, void 0, void 0, function* () {
            this.tables = (yield this.entityService.model()).models.map(x => ({
              label: x.name,
              value: x.name
            }));
            this.table = this.tables[0].value;
          });
        }
        loadTable(ct) {
          return __awaiter(this, void 0, void 0, function* () {
            const {
              start,
              size
            } = this.filter;
            const filter = this.search;
            let q = this.entityService.query({
              name: this.table
            });
            if (filter) {
              q = q.where({}, () => filter);
            }
            this.list = yield q.toPagedList({
              start,
              size
            });
          });
        }
        refreshSearch() {
          this.filter.filter = this.search;
          this.version++;
        }
        delete(e) {
          return __awaiter(this, void 0, void 0, function* () {
            yield this.entityService.delete(e);
            yield this.loadTable();
          });
        }
        edit(page, e) {
          return __awaiter(this, void 0, void 0, function* () {
            yield this.navigationService.openPage(page, {
              name: this.table,
              insert: false,
              model: e
            });
            yield this.loadTable();
          });
        }
        add(page) {
          return __awaiter(this, void 0, void 0, function* () {
            yield this.navigationService.openPage(page, {
              name: this.table,
              insert: true,
              model: {
                $type: this.table
              }
            });
            yield this.loadTable();
          });
        }
      });
      __decorate([Inject, __metadata("design:type", EntityService)], TableListViewModel.prototype, "entityService", void 0);
      __decorate([Inject, __metadata("design:type", NavigationService)], TableListViewModel.prototype, "navigationService", void 0);
      __decorate([Inject, __metadata("design:type", ReferenceService)], TableListViewModel.prototype, "referenceService", void 0);
      __decorate([Load({
        init: true
      }), __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", Promise)], TableListViewModel.prototype, "load", null);
      __decorate([Load({
        watch: true,
        watchDelayMS: 300
      }), __metadata("design:type", Function), __metadata("design:paramtypes", [CancelToken]), __metadata("design:returntype", Promise)], TableListViewModel.prototype, "loadTable", null);
      __decorate([Action({
        confirm: "Are you sure you want to delete this?"
      }), __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", Promise)], TableListViewModel.prototype, "delete", null);
    }
  };
});
//# sourceMappingURL=TableListViewModel.js.map