(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    var _a;
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.dotNetInit = void 0;
    var DotNet = (_a = window.dotNet) !== null && _a !== void 0 ? _a : {
        getClass: function (name) {
            throw new Error("dotNet is not available, the code is not running inside a WebAtoms.HybridWebView");
        }
    };
    DotNet.isAvailable = !!window.dotNet;
    function create(name, ns, nsAssembly) {
        return {
            configurable: true,
            enumerable: true,
            get: function () {
                var value = DotNet.getClass("".concat(ns, ".").concat(name, ", ").concat(nsAssembly));
                Object.defineProperty(this, name, {
                    enumerable: true,
                    configurable: true,
                    writable: true,
                    value: value
                });
                return value;
            }
        };
    }
    function dotNetInit(a, ns, nsAssembly) {
        for (var key in a) {
            if (key && Object.prototype.hasOwnProperty.call(a, key)) {
                var e = a[key];
                if (typeof e === "function") {
                    Object.defineProperty(a, key, create(key, ns, nsAssembly));
                }
            }
        }
    }
    exports.dotNetInit = dotNetInit;
    exports.default = DotNet;
});
//# sourceMappingURL=DotNet.js.map