import RootObject from "./RootObject";
export declare namespace WebAtoms {
    namespace Hybrid {
        class HybridApplication extends RootObject {
            static current: HybridApplication;
            static deviceToken: string;
            static badge: number;
            static appUrl: string;
            static urlRequested: string;
            static shareRequested: string;
            static refreshApp: () => void;
            static invokeBackButton: () => void;
        }
        class FilePickerService extends RootObject {
            static pickFileAsync: (title: string, accept?: string) => Promise<File>;
        }
        namespace Media {
            enum Preset {
                LowQuality = "LowQuality",
                MediumQuality = "MediumQuality",
                HighestQuality = "HighestQuality",
                Preset640x480 = "Preset640x480",
                Preset960x540 = "Preset960x540",
                Preset1280x720 = "Preset1280x720",
                Preset1920x1080 = "Preset1920x1080",
                Preset3840x2160 = "Preset3840x2160",
                Passthrough = "Passthrough"
            }
            class HybridMedia extends RootObject {
                static instance: HybridMedia;
                chooseVideoAsync(preset: Preset, progress: (n: any) => void): Promise<File>;
                encodeMP4Async(inputFile: string, preset: Preset, progress: (n: any) => void): Promise<string>;
            }
        }
        namespace Api {
            class GeoLocation extends RootObject {
                static getLocationAsync(): Promise<{
                    longitude: number;
                    latitude: number;
                }>;
            }
            class FileService extends RootObject {
                static createFile(name: string): string;
                static append(path: string, dataUri: string): Promise<number>;
            }
        }
    }
}
//# sourceMappingURL=WebAtoms.d.ts.map