System.register(["@web-atoms/core/dist/style/styled", "@web-atoms/core/dist/web/controls/AtomControl"], function (_export, _context) {
  "use strict";

  var styled, AtomControl, Animations;
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistStyleStyled) {
      styled = _webAtomsCoreDistStyleStyled.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }],
    execute: function () {
      styled.css`
    transition: all 0.5s ease-out;

    &:not([data-animation-state]) {
        display: none;
    }
    
    &[data-animation-state=down] {
        transform: translate(0,100%);
    }
    
    &[data-animation-state=normal] {
        transform: translate(0,0);   
    }
    `.installGlobal("[data-animate-slide=from-bottom]");
      styled.css`
    transition: all 0.5s ease-out;

    &:not([data-animation-state]) {
        display: none;
    }
    
    &[data-animation-state=up] {
        transform: translate(0,-100%);
    }
        
    &[data-animation-state=normal] {
        transform: translate(0,0);
    }
    `.installGlobal("[data-animate-slide=from-top]");
      _export("default", Animations = class Animations {});
      Animations.slideFromBottom = AtomControl.registerProperty("animate", "bottom-slide", (ctrl, e, v) => {
        e.dataset.animateSlide = "from-bottom";
        if (v) {
          e.dataset.animationState = "down";
          setTimeout(() => {
            e.dataset.animationState = "normal";
          }, 10);
          return;
        }
        if (e.dataset.animationState === "normal") {
          e.dataset.animationState = "down";
        }
        setTimeout(() => {
          e.removeAttribute("data-animation-state");
        }, 600);
      });
      Animations.slideFromTop = AtomControl.registerProperty("animate", "top-slide", (ctrl, e, v) => {
        e.dataset.animateSlide = "from-top";
        if (v) {
          e.dataset.animationState = "up";
          setTimeout(() => {
            e.dataset.animationState = "normal";
          }, 10);
          return;
        }
        if (e.dataset.animationState === "normal") {
          e.dataset.animationState = "up";
        }
        setTimeout(() => {
          e.removeAttribute("data-animation-state");
        }, 600);
      });
    }
  };
});
//# sourceMappingURL=Animations.js.map