System.register(["@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/style/styled"], function (_export, _context) {
  "use strict";

  var XNode, styled, css;
  function Button({
    id,
    icon,
    text,
    eventClick,
    href,
    target,
    title,
    styleDisplay,
    class: className,
    subClass
  }) {
    console.warn("Deprecated, use data-layout=icon-button");
    const cn = className !== null && className !== void 0 ? className : subClass ? subClass + " " + css : css;
    if (href) {
      if (text) {
        return XNode.create("a", {
          id: id,
          class: cn,
          target: target,
          title: title,
          styleDisplay: styleDisplay
        }, XNode.create("label", {
          class: "label"
        }, XNode.create("i", {
          class: icon
        }), text && XNode.create("span", {
          text: text
        })));
      }
    }
    return XNode.create("button", {
      id: id,
      class: cn,
      eventClick: eventClick,
      title: title,
      styleDisplay: styleDisplay
    }, XNode.create("label", {
      class: "label"
    }, XNode.create("i", {
      class: icon
    }), text && XNode.create("span", {
      text: text
    })));
  }
  _export("default", Button);
  return {
    setters: [function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistStyleStyled) {
      styled = _webAtomsCoreDistStyleStyled.default;
    }],
    execute: function () {
      css = styled.css`
    padding: 8px;
    margin-left: 3px;
    margin-right: 3px;
    border-radius: 9999px;
    display: inline-block;
    height: 40px;
    min-width: 40px;
    box-shadow: rgba(50, 50, 105, 0.07) 0px 2px 5px 0px, rgba(0, 0, 0, 0.03) 0px 1px 1px 0px;
    border: solid 1px rgba(0, 0, 0, 0.05);
    cursor: pointer;
    background-color: transparent;
    &.pressed {
        background-color: lightsteelblue;
    }
    &:hover {
        background-color: lightgreen;
    }
    & > label.label {
        display: flex;
        align-items: center;
        gap: 5px;
        & > .fad {
            font-size: larger;
            width: 100%;
            color: purple;
            cursor: pointer;
            &.red {
                color: red;
            }
        }
        & > span {
            white-space: nowrap;
        }
    }
`.installLocal();
      Button.className = css;
    }
  };
});
//# sourceMappingURL=Button.js.map