System.register(["@web-atoms/core/dist/core/types", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "./AtomRepeater", "./InlinePopup", "./styles/tooltip-style"], function (_export, _context) {
  "use strict";

  var CancelToken, XNode, ElementValueSetters, getParentRepeaterItem, InlinePopup, Tooltip, tooltips;
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistCoreTypes) {
      CancelToken = _webAtomsCoreDistCoreTypes.CancelToken;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      ElementValueSetters = _webAtomsCoreDistWebControlsAtomControl.ElementValueSetters;
    }, function (_AtomRepeater) {
      getParentRepeaterItem = _AtomRepeater.getParentRepeaterItem;
    }, function (_InlinePopup) {
      InlinePopup = _InlinePopup.default;
    }, function (_stylesTooltipStyle) {}],
    execute: function () {
      tooltips = new Map();
      ElementValueSetters.tooltip = (control, e, value) => {
        tooltips.set(e, [{
          control,
          tooltip: undefined
        }, value]);
        control.registerDisposable({
          dispose: () => {
            tooltips.delete(e);
          }
        });
      };
      document.body.addEventListener("pointerenter", ev => Tooltip.showTooltip(ev.target), true);
      document.body.addEventListener("pointerleave", ev => {
        const start = ev.target;
        setTimeout(() => {
          const item = tooltips.get(start);
          if (!item) {
            return;
          }
          const [host] = item;
          if (host.tooltip) {
            host.tooltip.cancel();
            host.tooltip = undefined;
          }
        }, 250);
      }, true);
      _export("default", Tooltip = class Tooltip extends InlinePopup {
        static showTooltip(start) {
          while (start) {
            const item = tooltips.get(start);
            if (!item) {
              start = start.parentElement;
              continue;
            }
            const [host, node] = item;
            if (!host.tooltip) {
              host.tooltip = new CancelToken();
              const reset = () => delete host.tooltip;
              let data = getParentRepeaterItem(start);
              if (data) {
                data = data[2];
              }
              class TooltipControl extends node {
                preCreate() {
                  this.element._logicalParent = start;
                  if (data) {
                    this.data = data;
                  }
                  const {
                    element
                  } = this;
                  this.enterEventDisposable = this.bindEvent(element, "mouseenter", () => {
                    setTimeout(() => {
                      tooltips.set(element, [{
                        tooltip: host.tooltip,
                        control: null
                      }, null]);
                      delete host.tooltip;
                      this.enterEventDisposable.dispose();
                    }, 10);
                  });
                  this.registerDisposable({
                    dispose: () => {
                      tooltips.delete(element);
                    }
                  });
                }
              }
              TooltipControl.show(start, XNode.create(TooltipControl, {}), {
                cancelToken: host.tooltip,
                alignment: "topRight"
              }).then(reset, reset);
            }
            break;
          }
        }
      });
    }
  };
});
//# sourceMappingURL=Tooltip.js.map