export declare const isFileType: (acceptType: string) => any;
export type FilesAvailableEventArgs<T = any> = CustomEvent<{
    files: File[];
    extra: T;
}>;
export interface IUploadParams<T = any> {
    "event-files-available"?: (ce: FilesAvailableEventArgs<T>) => any;
    uploadEvent?: string;
    accept?: string;
    capture?: string;
    multiple?: any;
    /** Will enforce that the selected file matches the given accept types */
    forceType?: boolean;
    maxSize?: number;
    upload?: boolean;
    /** Extra will hold other information that will be available in upload event */
    extra?: T;
    authorize?: boolean;
    ariaLabel?: string;
}
export default class UploadEvent {
    static AttachUploadAction({ uploadEvent, accept, capture, multiple, forceType, maxSize, extra, upload, authorize, ariaLabel, ...others }: IUploadParams): {
        "data-click-command": string;
        "data-upload-event": string;
        "data-accept": string;
        "data-multiple": string;
        "data-capture": string;
        "data-upload": string;
        "data-force-type": string;
        "data-max-size": string;
        "data-authorize": string;
        "aria-label": string;
        extra: any;
        "event-files-available"?: (ce: FilesAvailableEventArgs<any>) => any;
    };
}
//# sourceMappingURL=UploadEvent.d.ts.map