System.register(["tslib", "@web-atoms/core/dist/App", "@web-atoms/core/dist/core/Command", "@web-atoms/core/dist/core/StringHelper", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/web/services/PopupService"], function (_export, _context) {
  "use strict";

  var __rest, App, Command, StringHelper, AtomControl, PopupService, UploadEvent, acceptCache, isFileType, previousFile, uploadCommand, id;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistApp) {
      App = _webAtomsCoreDistApp.App;
    }, function (_webAtomsCoreDistCoreCommand) {
      Command = _webAtomsCoreDistCoreCommand.default;
    }, function (_webAtomsCoreDistCoreStringHelper) {
      StringHelper = _webAtomsCoreDistCoreStringHelper.StringHelper;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistWebServicesPopupService) {
      PopupService = _webAtomsCoreDistWebServicesPopupService.default;
    }],
    execute: function () {
      acceptCache = {};
      _export("isFileType", isFileType = acceptType => {
        var _a;
        function isFileTypeFactory(accept) {
          if (!accept || accept === "*/*") {
            return () => true;
          }
          const types = accept.split(/\,/g).map(x => {
            x = x.trim();
            if (x.startsWith(".")) {
              return file => file.name.endsWith(x);
            }
            if (x.endsWith("/*")) {
              const prefix = x.substring(0, x.length - 1);
              return file => file.type.startsWith(prefix);
            }
            return file => file.type === x;
          });
          return file => {
            for (const iterator of types) {
              if (iterator(file)) {
                return true;
              }
            }
            return false;
          };
        }
        return (_a = acceptCache[acceptType]) !== null && _a !== void 0 ? _a : acceptCache[acceptType] = isFileTypeFactory(acceptType);
      });
      uploadCommand = Command.create({
        name: "upload-command"
      });
      window.addEventListener(uploadCommand.eventName, ce => {
        if (ce.defaultPrevented) {
          return;
        }
        const element = ce.target;
        const authorize = element.getAttribute("data-authorize");
        if (authorize === "true") {
          if (!App.authorize()) {
            return;
          }
        }
        const multiple = element.getAttribute("data-multiple") === "true";
        const extra = element.extra;
        const upload = element.getAttribute("data-upload") === "true";
        const uploadEvent = StringHelper.fromHyphenToCamel(element.getAttribute("data-upload-event"));
        const chain = [];
        let start = element;
        while (start) {
          chain.push(start);
          start = start.parentElement;
        }
        previousFile === null || previousFile === void 0 ? void 0 : previousFile.remove();
        const file = document.createElement("input");
        file.type = "file";
        file.multiple = multiple;
        const accept = element.getAttribute("data-accept") || "*/*";
        file.accept = accept;
        const capture = element.getAttribute("data-capture");
        if (capture) {
          file.capture = capture;
        }
        file.style.position = "absolute";
        file.style.left = "-1000px";
        file.style.top = "-1000px";
        document.body.append(file);
        previousFile = file;
        const maxSize = parseInt(element.getAttribute("data-max-size") || "0", 10);
        const forceType = element.getAttribute("data-force-type") === "true";
        file.addEventListener("change", () => {
          let files = Array.from(file.files);
          let msg = "";
          if (forceType || maxSize) {
            const validated = [];
            const checkFileType = isFileType(accept);
            for (const iterator of files) {
              if (maxSize && iterator.size > maxSize) {
                msg += `Size of ${iterator.name} is more than ${maxSize}`;
                continue;
              }
              if (forceType) {
                if (!checkFileType(iterator)) {
                  msg += `${iterator.name} is invalid file.`;
                  continue;
                }
              }
              validated.push(iterator);
            }
            files = validated;
          }
          file.remove();
          previousFile = null;
          chain.reverse();
          while (chain.length) {
            const root = chain.pop();
            if (root.isConnected) {
              const control = AtomControl.from(root);
              if (msg) {
                control.app.runAsync(() => PopupService.alert({
                  message: msg
                }));
                if (files.length === 0) {
                  return;
                }
              }
              if (upload) {
                const doUploadEvent = new CustomEvent("uploadRequested", {
                  detail: {
                    files,
                    extra,
                    uploadEvent
                  },
                  bubbles: true,
                  cancelable: true
                });
                root.dispatchEvent(doUploadEvent);
                if (doUploadEvent.defaultPrevented) {
                  return;
                }
              }
              root.dispatchEvent(new CustomEvent(uploadEvent, {
                detail: {
                  files,
                  extra
                },
                bubbles: true
              }));
              break;
            }
          }
        });
        setTimeout(() => {
          file.dispatchEvent(new MouseEvent("click"));
        });
      });
      id = 1;
      _export("default", UploadEvent = class UploadEvent {
        static AttachUploadAction(_a) {
          var {
              uploadEvent = "filesAvailable",
              accept = "*/*",
              capture,
              multiple = false,
              forceType = true,
              maxSize = 524288000,
              extra,
              upload = true,
              authorize = true,
              ariaLabel = "Upload"
            } = _a,
            others = __rest(_a, ["uploadEvent", "accept", "capture", "multiple", "forceType", "maxSize", "extra", "upload", "authorize", "ariaLabel"]);
          return Object.assign(Object.assign({}, others), {
            "data-click-command": uploadCommand.name,
            "data-upload-event": uploadEvent,
            "data-accept": accept,
            "data-multiple": multiple ? "true" : "false",
            "data-capture": capture,
            "data-upload": upload ? "true" : "false",
            "data-force-type": forceType ? "true" : "false",
            "data-max-size": maxSize ? maxSize.toString() : undefined,
            "data-authorize": authorize.toString(),
            "aria-label": ariaLabel,
            extra
          });
        }
      });
    }
  };
});
//# sourceMappingURL=UploadEvent.js.map