System.register(["@web-atoms/core/dist/style/styled", "@web-atoms/core/dist/web/controls/AtomItemsControl"], function (_export, _context) {
  "use strict";

  var styled, AtomItemsControl, AtomButtonBar;
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistStyleStyled) {
      styled = _webAtomsCoreDistStyleStyled.default;
    }, function (_webAtomsCoreDistWebControlsAtomItemsControl) {
      AtomItemsControl = _webAtomsCoreDistWebControlsAtomItemsControl.AtomItemsControl;
    }],
    execute: function () {
      styled.css`
    display: inline-flex;
    gap: 0;
    align-items: center;
    border: solid 1px lightblue;
    border-radius: 10px;
    padding-left: 10px;
    padding-right: 10px;
    & > * {
        border-radius: 10px;
        padding: 5px;
        cursor: pointer;
        &:first-child {
            border-top-right-radius: 0;
            border-bottom-right-radius:0;
        }
        &:last-child {
            border-top-left-radius: 0;
            border-bottom-left-radius: 0;
        }
        &[data-item=selected-item] {
            background-color: lightblue;
        }
    }
`.installGlobal("*[data-button-bar=button-bar]");
      _export("default", AtomButtonBar = class AtomButtonBar extends AtomItemsControl {
        preCreate() {
          this.allowSelectFirst = true;
          super.preCreate();
          this.element.dataset.buttonBar = "button-bar";
          this.runAfterInit(() => {
            var _a;
            if (!this.selectedItem) {
              this.selectedItem = (_a = this.items[0]) !== null && _a !== void 0 ? _a : null;
            }
          });
        }
        createChild(df, data) {
          const child = super.createChild(df, data);
          child.element.dataset.buttonBarItem = "item";
          child.bindEvent(child.element, "click", () => {
            this.selectedItem = child.data;
          });
          child.bind(child.element, "data-item", [["data"], ["this", "selectedItem"]], false, (v1, v2) => v1 === v2 ? "selected-item" : "item", this);
          return child;
        }
      });
    }
  };
});
//# sourceMappingURL=AtomButtonBar.js.map