System.register(["tslib", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/web/core/AtomUI", "../mobile-app/MobileApp", "@web-atoms/core/dist/style/styled"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, BindableProperty, XNode, AtomControl, ChildEnumerator, MobileApp, styled, DesktopApp;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistWebCoreAtomUI) {
      ChildEnumerator = _webAtomsCoreDistWebCoreAtomUI.ChildEnumerator;
    }, function (_mobileAppMobileApp) {
      MobileApp = _mobileAppMobileApp.default;
    }, function (_webAtomsCoreDistStyleStyled) {
      styled = _webAtomsCoreDistStyleStyled.default;
    }],
    execute: function () {
      styled.css`

    html, body {
        width: 100%;
        height: 100%;
    }

    body {
        overflow: hidden;
        display: flex;
        justify-content: space-around;
        align-items: stretch;
        align-content: stretch;
        flex-direction: row;
    }

    *[data-desktop-app=desktop-app] {
        position: relative;
        overflow: hidden;
        display: grid;
        min-width: 900px;
        grid-template-rows: 1fr auto;
        grid-template-columns: auto 1fr auto;
        
        & > [data-page-element=app] {
            grid-row: 1;
            grid-column: 2;
            position: inherit; 
        }

        & > [data-page-element=menu-renderer] {
            grid-row: 1;
            grid-column: 1;
            overflow-x: hidden;
            overflow-y: auto; 
        }
        
        & > [data-page-element=side-bar] {
            grid-row: 1;
            grid-column: 3;
            overflow-x: hidden;
            overflow-y: auto; 
        }
        
        & > [data-page-element=status-bar] {
            grid-row: 2;
            grid-column: 1 / span 3;
            padding: 5px;
            margin-top: 2px;
            border-top: solid 1px lightgray;
            overflow: hidden; 
        }
    }
    `.withId("*[data-desktop-app=desktop-app]").installGlobal();
      _export("default", DesktopApp = class DesktopApp extends AtomControl {
        onPropertyChanged(name) {
          super.onPropertyChanged(name);
          if (!this.initialized) {
            return;
          }
          switch (name) {
            case "statusBarRenderer":
              this.recreate(name, "status-bar");
              break;
            case "menuRenderer":
              this.recreate(name, "menu-renderer");
              break;
            case "sideBarRenderer":
              this.recreate(name, "side-bar");
              break;
          }
        }
        init() {}
        recreate(renderer, name, remove = true) {
          var _a, _b, _c;
          const node = (_b = (_a = this[renderer]) === null || _a === void 0 ? void 0 : _a.call(this)) !== null && _b !== void 0 ? _b : undefined;
          if (remove) {
            for (const e of ChildEnumerator.enumerate(this.element)) {
              if (e.dataset.pageElement === name) {
                this.dispose(e);
                e.remove();
                break;
              }
            }
          }
          if (node) {
            const na = (_c = node.attributes) !== null && _c !== void 0 ? _c : node.attributes = {};
            na["data-page-element"] = name;
            this.render(XNode.create("div", null, node));
            return this.element.querySelector(`[data-page-element="${name}"]`);
          }
          return null;
        }
        create() {
          this.render(XNode.create("div", {
            "data-desktop-app": "desktop-app"
          }, XNode.create(MobileApp, {
            "data-page-element": "app"
          })));
          this.recreate("menuRenderer", "menu-renderer", false);
          this.recreate("sideBarRenderer", "side-bar", false);
          this.recreate("statusBarRenderer", "status-bar", false);
          this.initialized = true;
          this.runAfterInit(() => {
            this.app.runAsync(() => this.init());
          });
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Function)], DesktopApp.prototype, "menuRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], DesktopApp.prototype, "sideBarRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], DesktopApp.prototype, "statusBarRenderer", void 0);
    }
  };
});
//# sourceMappingURL=DesktopApp.js.map