import XNode from "@web-atoms/core/dist/core/XNode";
import { AtomControl } from "@web-atoms/core/dist/web/controls/AtomControl";
import "@web-atoms/data-styles/data-styles";
import { FilesAvailableEventArgs } from "../basic/UploadEvent";
export default class InlineHtmlEditor extends AtomControl {
    /**
     * Maximum undo limit
     */
    undoLimit: number;
    "event-content-changed"?: (ce: CustomEvent<string>) => any;
    "event-content-ready"?: (ce: CustomEvent<HTMLElement>) => any;
    "event-load-suggestions"?: (ce: CustomEvent<string>) => any;
    "event-files-available"?: (ce: FilesAvailableEventArgs) => any;
    editableSelector: string;
    sanitizeHtml: (node: HTMLElement) => void;
    /**
     * This will return the html content
     * after sanitizing everything, removing editable
     * attributes etc.
     */
    get htmlContent(): string;
    set htmlContent(v: string);
    get content(): string;
    set content(value: string);
    set toolbar(v: () => XNode);
    private version;
    private selection;
    private editor;
    private toolbarElement;
    private token;
    protected executeCommand(command: string, showUI?: boolean, value?: string): boolean;
    protected getStyle(name: string): any;
    protected queryCommandState(command: string): boolean;
    protected onContentSet(): void;
    protected saveSelection(): void;
    insertImage(s: any, e: Event): string | Promise<string>;
    protected preCreate(): void;
    protected updateQueryCommand(): void;
    protected onDrop(e: DragEvent): void;
    protected onPasteEvent(e: ClipboardEvent): void;
    protected contentModified(): void;
    private onContentInput;
}
//# sourceMappingURL=InlineHtmlEditor.d.ts.map