System.register(["@web-atoms/core/dist/core/AtomBridge", "@web-atoms/core/dist/web/controls/AtomControl"], function (_export, _context) {
  "use strict";

  var AtomBridge, AtomControl;
  function setupBridge() {}
  _export("default", setupBridge);
  return {
    setters: [function (_webAtomsCoreDistCoreAtomBridge) {
      AtomBridge = _webAtomsCoreDistCoreAtomBridge.AtomBridge;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }],
    execute: function () {
      AtomBridge.instance.createNode = function (target, node, binder, xNodeClass, creator) {
        let parent = null;
        const app = target.app;
        let e = null;
        if (typeof node.name === "string") {
          e = document.createElement(node.name);
          parent = e;
        } else {
          target = new node.name(app);
          e = target.element;
          parent = target;
        }
        const a = node.attributes;
        if (a) {
          for (const key in a) {
            if (a.hasOwnProperty(key)) {
              let element = a[key];
              if (element instanceof binder) {
                if (/^event/.test(key)) {
                  let ev = key.substr(5);
                  if (ev.startsWith("-")) {
                    ev = ev.split("-").map(s => s[0].toLowerCase() + s.substr(1)).join("");
                  } else {
                    ev = ev[0].toLowerCase() + ev.substr(1);
                  }
                  element.setupFunction(ev, element, target, e);
                } else {
                  element.setupFunction(key, element, target, e);
                }
              } else {
                if (element instanceof xNodeClass) {
                  const templateNode = element;
                  const name = templateNode.name;
                  if (typeof name === "string") {
                    element = ((bx, n) => class extends bx {
                      create() {
                        this.render(n);
                      }
                    })(creator, templateNode.children[0]);
                  } else {
                    element = ((base, n) => class extends base {
                      create() {
                        this.render(n);
                      }
                    })(name, templateNode.children[0]);
                  }
                }
                target.setLocalValue(e, key, element);
              }
            }
          }
        }
        const children = node.children;
        if (children) {
          for (const iterator of children) {
            if (typeof iterator === "string") {
              e.appendChild(document.createTextNode(iterator));
              continue;
            }
            if (typeof iterator.name === "string") {
              e.appendChild(this.createNode(target, iterator, binder, xNodeClass, creator));
            } else {
              const child = this.createNode(target, iterator, binder, xNodeClass, creator);
              if (parent instanceof AtomControl) {
                parent.append(child.atomControl || child);
              } else {
                parent.appendChild(child);
              }
            }
          }
        }
        return e;
      };
    }
  };
});
//# sourceMappingURL=setupBridge.js.map