import Command, { Commands } from "@web-atoms/core/dist/core/Command";

export default class AppCommands extends Commands {

    public static home = Command.create({
        route: "/",
        routeOrder: 1000,
        openPage: () => import("../pages/home/HomePage")
    });

    public static introduction = Command.create({
        route: "/docs/introduction",
        openPage: () => import("../pages/markdown/MDPage"),
        routeDefaults: {
            label: "Introduction",
            url: "@web-atoms/web-site/docs/general/introduction.md"
        }
    });

    public static binding = Command.create({
        route: "/docs/binding",
        openPage: () => import("../pages/markdown/MDPage"),
        routeDefaults: {
            label: "Binding",
            url: "@web-atoms/web-site/docs/general/binding.md"
        }
    });
    
    public static dependencyInjection = Command.create({
        route: "/docs/dependency-injection",
        openPage: () => import("../pages/markdown/MDPage"),
        routeDefaults: {
            label: "Binding",
            url: "@web-atoms/web-site/docs/general/dependency-injection.md"
        }
    });

    public static ajax = Command.create({
        route: "/docs/ajax-rest",
        openPage: () => import("../pages/markdown/MDPage"),
        routeDefaults: {
            label: "Binding",
            url: "@web-atoms/web-site/docs/general/ajax.md"
        }
    });

    public static styledCss = Command.create({
        route: "/docs/styled-css",
        openPage: () => import("../pages/markdown/MDPage"),
        routeDefaults: {
            label: "Binding",
            url: "@web-atoms/web-site/docs/web/styled.md"
        }
    });

    public static events = Command.create({
        route: "/docs/event-re-routing",
        openPage: () => import("../pages/markdown/MDPage"),
        routeDefaults: {
            label: "Binding",
            url: "@web-atoms/web-site/docs/web/event-re-routing.md"
        }
    });

    public static hiring = Command.create({
        route: "/about/hiring",
        openPage: () => import("../pages/markdown/MDPage"),
        routeDefaults: {
            label: "Binding",
            url: "@web-atoms/web-site/docs/general/hiring.md"
        }
    });
}